
#include"agchecker.h"
#include"srlearner.h"
#include"llearner2.h"
#include"prop_fa.h"
#include"cfa.h"
#include"config.h"


/*typedef Teacher<eSystem, eSys_CE, ePropDFA, Sys_explorer> eCFA_teacher;
typedef Learner<eCFA_teacher> eCFA_learner;
typedef AG_checker<eCFA_learner, eCFA_teacher, eSys_CE> eAGC;
*/

typedef Teacher<sSystem, sSys_CE, sPropDFA, Sys_expl_sym> sCFA_teacher;
//#define LL2 1
#ifdef LL2
typedef LLearner2<sCFA_teacher> sCFA_learner;
#else
typedef SRLearner<sCFA_teacher> sCFA_learner;
#endif
typedef AG_checker<sCFA_learner, sCFA_teacher, sSys_CE> sAGC;


extern Config config;

//template bool check_ag<eSystem,eSys_CE>( const eSystem&, const PropFA& , eSys_CE&);
/*
bool check_ag(const eSystem& sys, const ePropFA& _spec, eSys_CE& ce) {

	ePropDFA spec(_spec.has_sink());
	spec.construct_from(_spec);
        spec.negate();

        AG_mode ag_mode;
        if ( config.ag_type == Config::NC ) ag_mode = NC;
        else if ( config.ag_type == Config::CIRC ) ag_mode = CIRC;
        else assert(0);


	eAGC ag_checker(sys, spec, ag_mode);
	return ag_checker.run(ce);
}
*/
bool check_ag(const sSystem& sys, const sPropFA& _spec, sSys_CE& ce) {

	sPropDFA spec(_spec.has_sink());
	spec.construct_from(_spec);
        spec.negate();

        AG_mode ag_mode;
        if ( config.ag_type == Config::NC ) ag_mode = NC;
        else if ( config.ag_type == Config::CIRC ) ag_mode = CIRC;
        else assert(0);


	sAGC ag_checker(sys, spec, ag_mode);
	return ag_checker.run(ce);
}

template<class Learner, class Teacher, class Sys_CE>
bool AG_checker<Learner,Teacher,Sys_CE>::run_circ(Sys_CE& glb_ce) { 

//    vector<Sigma> l_sigma_vec;
    Sigma l_sigma_vec[100];

    //compute sys_vec, teachers and learners
    //vector<System> sys_vec, rest_sys_vec;
    //vector<Teacher> mat_vec;
    //vector<Learner> l_vec;
    System sys_vec[100];
    Teacher mat_vec[100];
    Learner l_vec[100];
    size_t N = sys.num_cfg_components();
    CHK(N>=2);
    const RW& env_rw = sys.get_env_rw();

    System tmp_sys = sys;
    RW sys_glb_rw; tmp_sys.get_glb_rw(sys_glb_rw);
    //Util::msg(2,"sys_glb_rw is " + sys_glb_rw.to_str()); 
    fa_get_glb_rw(spec,sys_glb_rw);
    //Util::msg(2,"sys_glb_rw is " + sys_glb_rw.to_str()); 

    Sigma glb_l_sigma;
    sys.get_concrete_comm_sigma(sys_glb_rw, glb_l_sigma);
    CHK ( !glb_l_sigma.empty() );

    for(size_t i=0; i< N; i++) {
        set<size_t> indices;
        indices.insert(i);
        System curr_sys(sys,indices,env_rw);
        //sys_vec.push_back( curr_sys );
        //System& curr_sys_ref = sys_vec[ sys_vec.size()-1 ]; 
        sys_vec[i] = curr_sys;
    //    System& curr_sys_ref = sys_vec[ i ]; 

        indices.clear(); 
        for(size_t j=0; j< sys.num_cfg_components(); j++) indices.insert(j);
        indices.erase(i);
        System rest_sys(sys,indices,env_rw);
        //rest_sys_vec.push_back( rest_sys );
        //System& rest_sys_ref = rest_sys_vec[ rest_sys_vec.size()-1 ]; 
        
        //rest_sys_vec[i] = rest_sys;
       // System& rest_sys_ref = rest_sys;

        //Sigma l_sigma;
        //compute_learner_sigma_circ(curr_sys_ref,rest_sys_ref,spec,l_sigma);
        //l_sigma_vec.push_back(l_sigma);
        l_sigma_vec[i] = glb_l_sigma;


        //setup teachers, learners
        //Teacher mat(curr_sys_ref,spec,l_sigma_vec[i]);
        Teacher mat(sys_vec[i],spec,glb_l_sigma);
        //mat_vec.push_back(mat); 
        mat_vec[i] = mat;
        
        //Learner learner( &(mat_vec[ mat_vec.size()-1 ]) );
        //l_vec.push_back(learner);
        Learner learner ( &(mat_vec[i]));
        l_vec[i] = learner;
        sys_vec[i].show_init_state();
    }


    //top-level loop
    bool retval = false;
    while(1) {
        //generate candidate for Ri: M_i || A \subseteq P
        size_t i;
        for(i=0; i<N; i++) {
            Util::message(2,"learning A for sys comp %d\n",i);      
            while(1) {
                Learner_CE ce;
                bool res = mat_vec[i].ask_cand_q(l_vec[i].get_new_candidate(),ce);
                if(res) break;      
                Util::message(3,"N%d: learning from ce=%s ...\n",i,ce.to_str().c_str());      
                l_vec[i].learn_ce(ce);
                //l_vec[i].get_new_candidate();
            }
            Util::msg(2,"finished learning assumption "+ int2str(i) +" ...\n");
        }
        Util::message(2,"finished learning assumptions ...\n");
        Util::message(2,"Now checking the last premise ...\n");

        vector<DFA> assmp_vec;

        for(i=0; i<N; i++) {
            DFA assmp_i = l_vec[i].get_prev_candidate();
            assmp_i.negate();
            assmp_vec.push_back( assmp_i );
        }

        System assmp_sys(assmp_vec, sys);
        Sys_CE ce;
        bool assmp_res = Sys_explorer(assmp_sys).check_prop(spec, ce);

        if(assmp_res) { retval = true; break; }
        else retval = false;
        //otherwise check if ce is correct or not, i.e., 
        Util::msg(2,"last premise CE: checking if "+ ce.to_str() + " is correct\n");
        glb_ce = ce;

        for(i=0; i<N; i++) {

            //check Mi || CE_abs \sat P
            Learner_CE mi_ce_abs;
            Sys_CE mi_ce;
            Util::msg(2,"Checking for M_"+ int2str(i) + "...");
            bool curr_res = mat_vec[i].check_M_ce_satisfy_spec(ce, mi_ce_abs, mi_ce);

            //if CE model checking fails then return false else add CE to assumption and repeat
            if(!curr_res) { 
                ce.merge_with(mi_ce);  
                glb_ce = ce;
            } 
            // else add CE to all assumptions
            else { l_vec[i].learn_ce(mi_ce_abs); 
                retval = true; //at least one Mi does not support CE_abs
                Util::msg(2,"Over learning for for M_"+ int2str(i) + "...");
            } 

        } //end for
        if (!retval) return retval;
    } //end while

    return retval;

}




