#include"cfa.h"
#include"dp.h"
#include"eval_ea_sym.h"
#include<sstream>


bool get_bop ( const string& s, op& o) {
    if ( s == "&&" )  { o = LandOp; return true; }
    else if ( s == "||" ) {o = LorOp; return true; }
    else if ( s == ":" || s == "==" ) { o = EqualOp; return true;}
    else if ( s == "!=" ) { o = NotEqualOp; return true;}
    else if ( s == "!" ) assert(0); 
    else return false;
}

bool get_const ( const string& s, Const &c ) {
    if ( s == "true" ) c = Const(true);
    else if ( s == "false" ) c = Const(false);
    else  {
        int n = atoi(s.c_str());
        c = Const(n);
    }
    return true;
}

Pexpr_bdd get_pexpr_from_str(const string& str) {
    string buf;
    stringstream ss(str);
    op curr_op;
    op eq_op;
    //Expr *res = ExprManager::get_true();
    int expr_done = 0;
    int num_exprs= 0;
    Pexpr_bdd res;
    Const c;
    Varref vr;
    
    while( ss >> buf ) {
        op o;
        //if ( buf[0] == '!' ) assert(0);
        
        if ( get_bop (buf, o) ) { 
            if ( o != EqualOp  && o != NotEqualOp ) { CHK( expr_done == 0 ); curr_op = o; }
            else { CHK(expr_done == 1); eq_op = o; expr_done++; }
        }
        else if ( expr_done == 2 ) {
            CHK(get_const (buf, c) ); 
            expr_done++;
        }
        else {
            CHK(expr_done==0);
            vr = Varref(buf);
            expr_done++;
        }

        if ( expr_done == 3 ) {
            if ( curr_op == LandOp || num_exprs == 0 ) {
                //Util::msg(2,"and with "+vr.to_str()+" = "+c.to_str());
                if ( eq_op == EqualOp )
                    res.add_val(0,vr,c);
                else if ( eq_op == NotEqualOp )
                    res.add_neq_val(0,vr,c);
                else assert(0);
            }
            else if ( curr_op == LorOp ) {
                Pexpr_bdd p;
                if ( eq_op == EqualOp )
                    p.add_val(0,vr,c);
                else if ( eq_op == NotEqualOp )
                    p.add_neq_val(0,vr,c);
                else assert(0);
                res.or_with(p);
                //Util::msg(2,"or with "+vr.to_str()+" = "+c.to_str());
            }
            else assert(0);
            expr_done = 0;
            num_exprs++;
        }
    }

    return res;

}

void eCFA_act::get_from_str(const string& str)  { 
    //reads.set_mem(mem); writes.set_mem(mem);
    Util::msg(4,"reads = "+reads.to_str()+", writes = "+writes.to_str());
    if( str.find('?') != string::npos ) {
        size_t pos = str.find('?');
        string var_name = str.substr(0,pos);
        string val = str.substr(pos+1,string::npos);
        Var_dcl vd(var_name); Const c(atoi(val.c_str()));
        Util::msg(4,"var = "+vd.to_str()+", const="+c.to_str() ); 
        set_val(0,vd,c);
    }
    else if ( str.find('!') != string::npos ) {
        size_t pos = str.find('!');
        string var_name = str.substr(0,pos);
        string val = str.substr(pos+1,string::npos);
        Var_dcl vd(var_name); Const c(atoi(val.c_str()));
        set_val(1,vd,c);
    }
    else assert(0);

   // Util::msg(4,"str is " + str + ", get from str: "+ to_str() );
}

void sCFA_act::get_from_str(const string& str) {
    /*if( str.find('?') != string::npos ) {
        size_t pos = str.find('?');
        string var_name = str.substr(0,pos);
        string val = str.substr(pos+1,string::npos);
        Const c;
        if ( val == "true" ) c = Const(true);
        else if ( val == "false" ) c = Const(false);
        else c =  Const (atoi(val.c_str()));
        Varref vr(var_name);
        Util::msg(4,"var = "+vr.to_str()+", const="+c.to_str() ); 
        set_val(0,vr,c);
    }
    else if ( str.find('!') != string::npos ) {
        size_t pos = str.find('!');
        string var_name = str.substr(0,pos);
        string val = str.substr(pos+1,string::npos);
        Const c;
        if ( val == "true" ) c = Const(true);
        else if ( val == "false" ) c = Const(false);
        else c =  Const (atoi(val.c_str()));
        Varref vr(var_name); 
        set_val(1,vr,c);
    }
    else assert(0); //to add: expr.get_from_str
    */
    Pexpr_bdd p = get_pexpr_from_str(str);
    set_r(-1,p);
    //Util::msg(2,"str is " + str + ", get from str: "+ to_str() );

}


bool sCFA_act::matches (const sCFA_act& act) const  {
    //Util::msg(2,"checking if "+this->to_str()+" matches "+act.to_str());
    CHK( has_globals_only() && act.has_globals_only() );
    return get_glb_pexpr().matches ( act.get_glb_pexpr() );
} 


