#include"cfg_comp.h"
#include"eval_ea.h"

struct build_sym_act_vis {

    Act_eval_type eval_type;
    const Guard_expr_list& cond_list;
    map<Var_dcl, Case_map>& var2cases;
    
    build_sym_act_vis(const _Action_& act, const Guard_expr_list& _cond_list, 
                    map<Var_dcl, Case_map>& _var2cases) 
                    : cond_list(_cond_list), var2cases(_var2cases) 
        { VAR::apply_visitor(*this,act); }


    void operator() (const Assign& a) {
        assert(0);
        //const Varref& vr = TUP::get<0>(a);
        //const Expr* e = TUP::get<1>(a);
        //Var_dcl vd = vr.to_vd_plain();
        eval_type = IMM; 
    }

    void operator() (const DAssign& a) {
        const Varref& vr = TUP::get<0>(a);
        const Expr* e = TUP::get<1>(a);
        Var_dcl vd = vr.to_vd_plain();
        var2cases[vd][cond_list] = e;
        eval_type = DELTA; 
    }
    void operator() (const Send& send) {
        //	Var_dcl vd = eval_send_chan_name(send,s,pid);
        const Send_args& el = TUP::get<1>(send);
        CHK(el.size() == 1);
        const Send_arg sa = *(el.begin());
        CHK(sa.is_const());
        Val v = eval_const(sa.get_const());
        eval_type = IMM; //NMT
    }

    void operator() (const Recv& recv) {
        assert(0);
        //	Var_dcl vd = eval_recv_chan_name(recv,s,pid);
        //	Val val = s.eval(pid,vd);

        //match all constants
        //	CHK( eval_recv_matches_s(recv,s,pid) );


        /*const Recv_args& ras = TUP::get<1>(recv);
        CHK(ras.size() == 1);
        for(uint i=0; i<ras.size(); ++i) {
            if( ras[i].is_const() ) continue;
            const Varref& vri = (ras[i]).get_varref();
            //          Var_dcl vdi = eval_varref(vri,s,pid);
            //        s_diff.set_val(pid,vdi,val); //assume: no chan/event vars are in args
        }*/
        eval_type = IMM; //NMT
    }

    void operator() (const Pause& pause) {  eval_type = PAUSE; } //IMM: NMT


};


Act_eval_type build_sym_act(const CFG_action& act, const Guard_expr_list& cond_list, 
                        map<Var_dcl, Case_map>& var2cases) {

    build_sym_act_vis vis(act, cond_list, var2cases);
    return vis.eval_type;
}



void CFG_comp::build_sym_form_rec(const CFG_node& n, Guard_expr_list& cond_list,
                        set<CFG_node>& visited, map<Var_dcl, Case_map>& var2cases) {
    visited.insert(n);
    Guard_expr g_back ;
    
    if (main_cfg.is_if_end(n) ) {
       // Util::msg(2,"if_end: node is "+n.to_str());
        CHK( !cond_list.empty() );
        g_back = cond_list.back();
        cond_list.pop_back(); //stack
    }
    
    list<CFG_edge> elist;
    main_cfg.get_out_edges(n, elist);
    //find else edge guard
    Guard_expr else_expr_guard;
    const_foreach(it, elist) {
        const CFG_edge& e = *it;
        if( e.has_true_guard() ) continue;
        else if (!e.has_else_guard()) {
            const Expr* expr = ExprManager::get_expr(NotUOp, (Expr*)e.get_guard()); 
            else_expr_guard.push_back( expr );
        }
    }
    
    const_foreach(it2, elist) {
        const CFG_edge& e = *it2;
        const CFG_node& opp = e.target();
        if ( visited.find(opp) != visited.end() ) continue;

        //list<const Expr*> new_cond_list = cond_list;
        const Expr* curr_guard = e.get_guard();
        const CFG_actions& acts = e.get_acts();

        //handle guards; build new_cond_list
        if( main_cfg.is_if_begin(n) ) {
   //         Util::msg(2,"if_begin: node is "+n.to_str());
            if ( e.has_else_guard() ) {
               cond_list.push_back(else_expr_guard);
            }
            else //if (!e.has_true_guard()) {
                cond_list.push_back(curr_guard);
            //}
        }

        //handle acts
        CHK( acts.size() < 2);
        const_foreach(ita, acts) {
            Act_eval_type eval_type = build_sym_act(*ita, cond_list, var2cases);
            if ( eval_type == PAUSE ) continue;
        }

        build_sym_form_rec(opp,cond_list, visited,var2cases);

        if( main_cfg.is_if_begin(n) ) {
            //if ( e.has_else_guard() || !e.has_true_guard()) {
                cond_list.pop_back();
            //}
        }
    }//end const elist

    if (main_cfg.is_if_end(n) ) {
        cond_list.push_back(g_back);
    }

}



