#ifndef _CONFIG_H
#define _CONFIG_H

struct Config {

enum Run_type {RT_NONE, EXPLORE, CHECK_PROP};
enum CP_type { CP_BASIC, CP_AGR };
enum AG_type { AG_NONE, NC, CIRC };


Run_type run_type;
CP_type cp_type;
AG_type ag_type;
string prop_file_name, model_file_name;

Config () {
    run_type = RT_NONE; cp_type = CP_BASIC; ag_type = AG_NONE;
}

void init(const vector<string>& args) {
    vector<string>::const_iterator it = args.begin();
    while(1) {
        string s = *it;
        if( s == "-r" ) { //run type
            it++; CHK ( it != args.end() ); s = *it;
            if( s == "e" ) run_type = EXPLORE;
            else if ( s== "cp" ) run_type = CHECK_PROP;
            else assert(0);
        }
        else if (s == "-ag") {
            run_type = CHECK_PROP;
            cp_type = CP_AGR;
            it++; CHK ( it != args.end() ); s = *it;
            if ( s == "nc" ) ag_type = NC;
            else if (s == "c" ) ag_type = CIRC;
            else assert(0);
        }
        else if (s == "-p") {
            it++; CHK ( it != args.end() );
            prop_file_name = *it;
        }
        else if (s == "-f") {
            it++; CHK ( it != args.end() );
            model_file_name = *it;
        }
        else {
            Util::err(true, "Invalid cmdline option...exiting");
        }
        it++;
        if( it == args.end() ) break;
    }
}




};

#endif
