#include<stdlib.h>
#include"eval_ea.h"
#include"proc_edge.h"
#include"id_diff.h"



struct Varref_to_Var_dcl {
  const Sys_state& st;
  int pid;
  Var_dcl vd;
  
  Varref_to_Var_dcl(const Sys_state& _st, int _pid) : st(_st), pid(_pid) {}
  void operator() (const SymbolRef& sr) { 
      vd = Var_dcl(Symbol(sr));
  }

  void operator() (const ArrayRef& ar) { 
      assert(0);
      //string s = TUP::get<0>(ar);
      //s += (TUP::get<1>(ar))->to_str();
  }
  void operator() (const BvRef& br) { 
      assert(0);
      //string s = TUP::get<0>(ar);
      //s += (TUP::get<1>(ar))->to_str();
  }
  template<class T>
  void operator() (const T& t) { cout<<"Unsupported Var_dcl convertion for this type\n"; assert(0); }
};

Var_dcl eval_varref(const Varref& vr, const Sys_state& s, int pid) {
  Varref_to_Var_dcl vis_vr(s, pid);
  apply_visitor(vis_vr,vr);
  return vis_vr.vd;
}


Val apply_op(op o, Val v1, Val v2) {
  switch(o) {
      case XorOp: return (v1 ^ v2);
      case OrOp: return (v1 | v2);
      case AndOp: return (v1 & v2);
      case EqualOp: return (v1 == v2);
      case LorOp: return (v1 || v2);
      case LandOp: return (v1 && v2);
      case NotEqualOp: return (v1 != v2);
      case LessOp: return (v1 < v2);
      case GreaterOp: return (v1 > v2);
      case LessEqualOp: return (v1 <= v2);
      case GreaterEqualOp: return (v1 >= v2);
      case LshiftOp: return (v1 << v2);
      case RshiftOp: return (v1 >> v2);
      case PlusOp: return (v1 + v2);
      case MinusOp: return (v1 - v2);
      case TimesOp: return (v1 * v2);
      case DivOp: return (v1 / v2);
      case ModOp: return (v1 % v2);
      default: assert(0);
  }
}


Val apply_uop(uop o, Val v) {
  switch(o) {
      case PlusUOp: return v;
      case MinusUOp: return -v;
      case NegUOp: return !v;
      case NotUOp: return !v;
      default: assert(0);
  }
}


struct Const_eval {
    int v;
    
    Const_eval(const Const& c) { VAR::apply_visitor(*this,c);}

    void operator() (bool b) {
        v = (b)?1:0;
    }

    void operator() (Num n) {
        v = n;
    }

    template<class T> void operator() (const T& t) {assert(0); }
};


int eval_const(const Const& c) {
	Const_eval vis_c(c);
	return vis_c.v;
}



struct expr_visitor {

  expr_visitor_mode m;
  const Sys_state& s;
  int pid;

  Val result;

  expr_visitor(expr_visitor_mode _m, const Sys_state& _s, int _pid): m(_m), s(_s), pid(_pid), result(0) {}


  void operator() (const BinOp& bop) {
    const Expr* e1 = TUP::get<0>(bop);
    op o = TUP::get<1>(bop);
    const Expr* e2 = TUP::get<2>(bop);
    const Exprt& et1 = *e1;
    const Exprt& et2 = *e2;

    Val val1;

    switch (m) {
      case EVAL:
          apply_visitor(*this,et1);
          val1 = result;
          apply_visitor(*this,et2);
          result = apply_op(o,val1, result);
          break;
      default: assert(0);
    }
  }

  void operator() (const TernOp& e)  {
    op o = TUP::get<0>(e);
    CHK ( o == IteOp );
    const Expr* e1 = TUP::get<1>(e);
    const Expr* e2 = TUP::get<2>(e);
    const Expr* e3 = TUP::get<3>(e);
    const Exprt& et1 = *e1;
    const Exprt& et2 = *e2;
    const Exprt& et3 = *e3;

    switch (m) {
      case EVAL:
          apply_visitor(*this,et1);
          if( result.is_t() ) apply_visitor(*this,et2);
          else if ( result.is_f() ) apply_visitor(*this, et3);
          else result = Val::ValX;

          break;
      default: assert(0);
    }

  }
  
  void operator() (const UnOp& e) {
    uop o = TUP::get<0>(e);
    const Expr* e1 = TUP::get<1>(e);
    const Exprt& et1 = *e1;


    switch (m) {
      case EVAL:
          apply_visitor(*this,et1);
          result = apply_uop(o, result);
          break;
      default: assert(0);
    }
  }

  void operator() (const Varref& vr) {
    switch (m) {
      case EVAL: {
          Var_dcl vd = eval_varref(vr,s,pid);
          result = s.eval(pid,vd);
                 }
          break;
      default: assert(0);
    }

  }

  void operator() (const Const& c) {
    
    switch (m) {
      case EVAL:
          result = eval_const(c);
          break;
      default: assert(0);
    }
  }

  void operator() (const Expr_Enum& ee) {
    switch(ee) {
      case Else_expr:
          switch(m) {
              case EVAL:
                  fprintf(stderr," how do i evaluate ELSE eval?\n"); assert(0);
                  break;
              default: assert(0);
          }
      default: assert(0);
    }
  }

  void operator() (const ChanInit& ci) { //all channel inits are static
    assert(0);
  }

};




Val eval_expr(const Expr* e, const Sys_state& s, int pid) {
  expr_visitor ev(EVAL,s,pid);
  assert( e != NULL);
  apply_visitor(ev,*e);
  return ev.result;
}


//---------------------------- EVAL CFG_action --------------------------------

Var_dcl eval_send_chan_name(const Send& send, const Sys_state& s, int pid) {
	const Varref& vr = TUP::get<0>(send);
	return eval_varref(vr,s,pid);
}

Var_dcl eval_recv_chan_name(const Recv& recv, const Sys_state& s, int pid) {
	const Varref& vr = TUP::get<0>(recv);
	return eval_varref(vr,s,pid);
}

Val eval_send_arg (const Send_arg& sa, const Sys_state& s, int pid) {
	return eval_expr(sa.get_expr(),s,pid);
}


// --------------------- Action_eval

bool eval_recv_args_match_val(const Recv_args& ras, Val val) {
	assert(ras.size() == 1);
	for(size_t i=0; i<ras.size(); ++i) {
		const Recv_arg& ra = ras[i];
		if (ra.is_const() )  {
			Val v = eval_const(ra.get_const());
                        tbool tb = (v != val);
                        if ( tb.is_t() ) return false;
                        //if false, then definite match; if x, then may match
		}
	}
	return true;
}

//get recv_arg value; if matches state (unknown value matches all- not 3-valued)
bool eval_recv_matches_s(const Recv& recv, const Sys_state& s, int pid) {
	 Var_dcl vd = eval_recv_chan_name(recv,s,pid);
	 Val v = s.eval(pid, vd);
	 return eval_recv_args_match_val(TUP::get<1>(recv), v);
}

bool eval_cfg_edge_chan_act_enabled (const CFG_edge& ce, const Sys_state& s, int pid) {
    bool retval;
    if( ce.get_type() == SEND) {
        //always enabled :
        //exceptions: send on event and event is already high : choose earlier event
        //exceptions: send on channel and channel is written to in the same cycle -> flag err

        retval = true;
    }
    else {
        CHK (ce.get_type() == RECV);
        //get recv_arg value; if matches state (unknown value matches all- not 3-valued)
        //then enabled
        const Recv& recv = VAR::get<Recv>(ce.get_comm_act());
        retval = eval_recv_matches_s(recv,s,pid);
    }
    return retval;
}

struct Action_eval_vis {

	const Sys_state& s;
	int pid;
	Sys_state_diff& s_diff;
        //bool ret; /* ret is redundant, TODO: use eval_type instead*/
        Act_eval_type eval_type;

	Action_eval_vis(const Sys_state& _s, int _pid, Sys_state_diff& _s_diff) 
                    : s(_s), pid(_pid), s_diff(_s_diff) {}

	void operator() (const Assign& a) {
		const Varref& vr = TUP::get<0>(a);
		const Expr* e = TUP::get<1>(a);
		Val v = eval_expr(e,s,pid);
		Var_dcl vd = eval_varref(vr,s,pid);
		s_diff.set_val(pid,vd,v);
                eval_type = IMM;
	}

	void operator() (const DAssign& a) {
		const Varref& vr = TUP::get<0>(a);
		const Expr* e = TUP::get<1>(a);
		Val v = eval_expr(e,s,pid);
		Var_dcl vd = eval_varref(vr,s,pid);
		s_diff.set_val(pid,vd,v);
                eval_type = DELTA;
	}
	void operator() (const Send& send) {
		Var_dcl vd = eval_send_chan_name(send,s,pid);
		const Send_args& el = TUP::get<1>(send);
                CHK(el.size() == 1);
                const Send_arg sa = *(el.begin());
                CHK(sa.is_const());
                Val v = eval_const(sa.get_const());
		s_diff.set_val(vd,v);
                eval_type = IMM; //NMT: we need another send !!); or scrap send
	}

	void operator() (const Recv& recv) {
		Var_dcl vd = eval_recv_chan_name(recv,s,pid);
		Val val = s.eval(pid,vd);
                
                //match all constants
		CHK( eval_recv_matches_s(recv,s,pid) );


		const Recv_args& ras = TUP::get<1>(recv);
                CHK(ras.size() == 1);
		for(uint i=0; i<ras.size(); ++i) {
                    if( ras[i].is_const() ) continue;
                    const Varref& vri = (ras[i]).get_varref();
                    Var_dcl vdi = eval_varref(vri,s,pid);
                    s_diff.set_val(pid,vdi,val); //assume: no chan/event vars are in args
		}
                eval_type = IMM; //NMT
	}

        void operator() (const Pause& pause) {  eval_type = PAUSE; } //IMM: NMT

};

Act_eval_type eval_cfg_act(const Sys_state& s, const CFG_action& act, int pid, Sys_state_diff& s_diff) {
      Action_eval_vis va(s,pid,s_diff);
      apply_visitor(va,act);
      return va.eval_type;
      //cout<<"eval_act: s_diff is "<<s_diff.to_str() <<endl;
}

void eval_cfa_act(const Sys_state& s, const eCFA_act& act, Sys_state_diff& s_diff) {
    const Diff_acts& writes = act.get_writes();
    Sys_state_diff sd(s.get_mem(), writes);
    //Util::msg(2,"eval_cfa_act: add_check{");
    s_diff.update_with(sd);
    //Util::msg(2,"}");
}

/*** Eval for CFG_edge, Proc_edge, Prop_edge  ****/

tbool eval_guard_cfg_edge (const Sys_state& s, const CFG_edge& ce, int pid) {
    const CFG_guard& ceg = ce.get_guard();
    if(ceg == CFG_stmt::guard_true) return true;
    Val val = eval_expr(ceg,s,pid);
    if (val.is_f()) return false;
    else if ( val.is_t()) return true;
    else return tbool::tboolX;
}

bool eval_guard_cfa_edge (const Sys_state& s, const eCFA_edge& ce, int pid) {
    const eCFA_act& act = ce.get_act();
    const Diff_acts& reads = act.get_reads();
    Sys_state_diff reads_sd(s.get_mem(), reads);
    return s.agrees_with_global(reads_sd);
}

void concretize_cfg_edge(CFG_edge& e, const Sys_state& s, int pid) {
    Edge_type etype = e.get_type();
    if( etype == SEND ) {
        //concretize send
        const Send& send = VAR::get<Send>(e.get_comm_act());
        const Send_args& el = TUP::get<1>(send);
        Send_args el2;
        const_foreach(it, el) {
            Val v;
            v = eval_send_arg(*it,s,pid);
            Expr* e = ExprManager::get_expr(Const(v.to_int()));
            el2.push_back(e);
        }
        Send send_res = Send(TUP::get<0>(send),el2);
        e.set_act( CFG_action(send_res));
    }
    else if( etype == RECV ) { //do nothing
        /*
           const Recv& recv = VAR::get<Recv>(e.get_comm_act());
           const Recv_args& ras = TUP::get<1>(recv);
           Recv_args ras2;
           const_foreach(it, ras) {
           eval_recv_arg_mtype_vis vis(mtype_indices);
           VAR::apply_visitor(vis,*it);
        //cout<<"recv arg res is "<<to_str(vis.ra_res)<<endl;
        ras2.push_back(vis.ra_res);
        }
        Recv recv_res = Recv(TUP::get<0>(recv),ras2);
        e.set_act(CFG_action(recv_res));
         */
    }
    else assert(0); //OTHER
}

// -------- Eval Proc Edge -------------
struct eval_proc_edge_vis {
	const Sys_state& s;
	int pid;
	Sys_state_diff& s_diff;
        bool ret;
	eval_proc_edge_vis(const Sys_state& _s, int _pid, Sys_state_diff& _s_diff) 
                : s(_s), pid(_pid), s_diff(_s_diff), ret(true) {}

	void operator() (const CFG_edge& ce) {
		const CFG_actions& acts = ce.get_acts();
		//Semantics: evaluate one CFG_action after another in sequence; atomically execute all cfg_actions
		//multiple writes to a variable -> final result = last write value, mult reads
		const_foreach(it, acts) Util::msg(5,it->to_str()+"\n");

                CHK(acts.size() <= 1);
		const_foreach(it, acts) {
                    Act_eval_type eval_type = eval_cfg_act(s,*it,pid,s_diff); 
                    if ( eval_type == PAUSE ) ret = false;
		}
		s_diff.set_pcval(pid, ce.target().get_pc());
                
	}

	void operator() (const eCFA_edge& e) {
		const eCFA_act& act = e.get_act();
		eval_cfa_act(s,act,s_diff);  
		//s.apply_diff(s_diff);
		s_diff.set_cfa_state(pid, e.target());
	}

	template<class T>
	void operator() (const T& t) { Util::error(false, "not handled"); CHK(0); }
};

bool eval_proc_edge(const Proc_edge& pe, const Sys_state& s, Sys_state_diff& s_diff ) {
	eval_proc_edge_vis vis(s, pe.get_pid(), s_diff);
	VAR::apply_visitor(vis, pe.get_edge());
        return vis.ret;
}

// ------------- Eval_proc_edge_ID_vis ----------------

struct eval_proc_edge_ID_vis {
	const Sys_state& s;
	int pid;
	ID_diff& idd;
        bool ret;

	eval_proc_edge_ID_vis(const Sys_state& _s, int _pid, ID_diff& _idd) 
                : s(_s), pid(_pid), idd(_idd), ret(true) {}

	void operator() (const CFG_edge& ce) {
		const CFG_actions& acts = ce.get_acts();
		//Semantics: evaluate one CFG_action after another in sequence; atomically execute all cfg_actions
		//multiple writes to a variable -> final result = last write value, mult reads
		const_foreach(it, acts) Util::msg(5,it->to_str()+"\n");

                CHK(acts.size() <= 1);
                Sys_state_diff sd(s.get_mem());
                Act_eval_type eval_type = NONE;

		const_foreach(it, acts) {
                   eval_type = eval_cfg_act(s,*it,pid,sd); 
		}


                if( eval_type == IMM ) {
                    idd.apply_imm_diff(sd,OW);
                    idd.set_imm_pcval(pid, ce.target().get_pc());
                }
                else if (eval_type == DELTA) {
                    idd.apply_delta_diff(sd,OW);
                    idd.set_imm_pcval(pid, ce.target().get_pc());
                }
                else if ( eval_type == PAUSE ) {
                    ret = false;
                    idd.set_imm_pcval(pid, ce.target().get_pc());
                } 
                else if ( eval_type == NONE ) {
                    idd.set_imm_pcval(pid, ce.target().get_pc());
                }
                else assert(0);
                
	}

	void operator() (const eCFA_edge& e) {
		const eCFA_act& act = e.get_act();
               // Util::msg(2,"evaluating cfa edge "+ e.to_str());
                Sys_state_diff sd(s.get_mem());
		eval_cfa_act(s,act,sd);  
		//s.apply_diff(s_diff);
		sd.set_cfa_state(pid, e.target());
                idd.apply_delta_diff(sd);
	}

	template<class T>
	void operator() (const T& t) { Util::error(false, "not handled"); CHK(0); }
};


bool eval_proc_edge_ID(const Proc_edge& pe, const Sys_state& s, ID_diff& idd) {
    eval_proc_edge_ID_vis vis(s, pe.get_pid(), idd);
    VAR::apply_visitor(vis, pe.get_edge());
    return vis.ret;
}
