
#ifndef EEC_H
#define EEC_H

#include"expr.h"
#include"cfg.h"
#include"val.h"
#include"sys_state.h"


//--------------------------- Expr -----------------------------------

int eval_const(const Const& c);
Var_dcl eval_varref(const Varref& vr, const Sys_state& s, int pid);
Val eval_expr(const Expr* e, const Sys_state& s, int pid) ;



//--------------------------- CFG -----------------------------------

//--------------- EVAL CFG_action_name ------------------------//

enum Act_eval_type { IMM, DELTA, PAUSE, NONE }; 


Var_dcl eval_send_chan_name(const Send& send, const Sys_state& s, int pid);
Var_dcl eval_recv_chan_name(const Recv& recv, const Sys_state& s, int pid);



struct Action_chan_name_vis {

    const Sys_state& s;
    int pid;
    Var_dcl vd;

    Action_chan_name_vis(const Sys_state& _s, int _pid) : s(_s), pid(_pid) {}

    void operator() (const Send& send) {
	 	vd = eval_send_chan_name(send,s,pid);
    }

    void operator() (const Recv& recv) {
	 	vd = eval_recv_chan_name(recv,s,pid);
    }

    template<typename T> void operator() (const T& t) {printf("Improper CFG_action type\n"); assert(0); }
}; 


template<class Action>
Var_dcl eval_act_chan_name(const Action& act, const Sys_state& s, int pid) {
    Action_chan_name_vis vis(s, pid);
    VAR::apply_visitor(vis,act);
    return vis.vd;
}

template<class Chan_edge>
Var_dcl eval_edge_chan_name(const Chan_edge& e, const Sys_state& s, int pid) {
	return eval_act_chan_name(e.get_comm_act(), s, pid);
}

bool eval_cfg_edge_chan_act_enabled (const CFG_edge& ce, const Sys_state& s, int pid) ;

tbool eval_guard_cfg_edge (const Sys_state& s, const CFG_edge& ce, int pid) ;

#endif
