#include<stdlib.h>
#include"eval_ea_sym.h"
#include"naming.h"
#include"ssystem.h"
#include"foci_dp.h"
#include"bdd_dp.h"

//#include"proc_edge.h"
//#include"id_diff.h"

/*

struct Varref_to_Var_dcl {
  const Sys_state& st;
  int pid;
  Var_dcl vd;
  
  Varref_to_Var_dcl(const Sys_state& _st, int _pid) : st(_st), pid(_pid) {}
  void operator() (const SymbolRef& sr) { 
      vd = Var_dcl(Symbol(sr));
  }

  void operator() (const ArrayRef& ar) { 
      assert(0);
      //string s = TUP::get<0>(ar);
      //s += (TUP::get<1>(ar))->to_str();
  }
  void operator() (const BvRef& br) { 
      assert(0);
      //string s = TUP::get<0>(ar);
      //s += (TUP::get<1>(ar))->to_str();
  }
  template<class T>
  void operator() (const T& t) { cout<<"Unsupported Var_dcl convertion for this type\n"; assert(0); }
};

Var_dcl eval_varref(const Varref& vr, const Sys_state& s, int pid) {
  Varref_to_Var_dcl vis_vr(s, pid);
  apply_visitor(vis_vr,vr);
  return vis_vr.vd;
}
*/


template<class DP>
typename DP::expr apply_op(op o, typename DP::expr v1, typename DP::expr v2, DP& dp) {

   // DP::expr a[2];
//    a[0] = v1; a[1] = v2;

    switch(o) {
        case LorOp:
        case OrOp: return dp.mk_or(v1,v2);

        case AndOp: 
        case LandOp: return dp.mk_and(v1,v2);

        case EqualOp: return dp.mk_eq(v1,v2);
        case NotEqualOp: return dp.mk_diseq(v1,v2);

        case LessOp: 
            return dp.mk_lt(v1,v2);
        case GreaterOp: 
            return dp.mk_gt(v1,v2);
        case LessEqualOp: 
            return dp.mk_le(v1,v2);
        case GreaterEqualOp:
            return dp.mk_ge(v1,v2);

        case PlusOp: 
            return dp.mk_sum(v1,v2);
        case MinusOp: 
            return dp.mk_sub(v1,v2);
        case TimesOp: 
            return dp.mk_mul(v1,v2);
        case XorOp: 
         {
            //a[0] = v1;
            //a[1] = dp.mk_not(v2);
            typename DP::expr f1 = dp.mk_and(v1,dp.mk_not(v2));
            //a[0] = dp.mk_not(v1);
            //a[1] = v2;
            typename DP::expr f2 = dp.mk_and(dp.mk_not(v1), v2);
            //a[0] = f1;
            //a[1] = f2;
            return dp.mk_or(f1,f2);
         }
        case DivOp: //return (v1 / v2);
        case LshiftOp:// return (v1 << v2);
        case RshiftOp: //return (v1 >> v2);
        case ModOp:// return (v1 % v2);
        default: assert(0);
    }
}

template<class DP>
typename DP::expr apply_uop(uop o, typename DP::expr v, DP& dp) {
  switch(o) {
      case PlusUOp: return v;

      case NegUOp: 
      case NotUOp: return dp.mk_not(v);

      case MinusUOp: //return -v;
      default: assert(0);
  }
}





template<class DP>
typename DP::expr eval_name_expr(DP& dp, const Var_dcl& vd, Pid pid, int depth)  {
    string name = sSystem::globals.get_glb_name(vd, pid, depth);
    return dp.get_var_expr(name);
}

template<class DP>
typename DP::expr eval_sym_varref ( DP& dp, const Varref& vr, Pid pid, int depth) {
    Var_dcl vd = vr.to_vd_plain();
    return eval_name_expr(dp,vd,pid,depth);
}

template<class DP>
void DP_declare_varrefs ( DP& dp, const set<Varref>& vrs, Pid pid, int depth) {
    const_foreach(it, vrs) {
        Var_dcl vd = it->to_vd_plain();
        //typename DP::DP_type dty = sSystem::globals.get_DP_ty (dp, vd, pid);
        Ty ty = sSystem::globals.get_ty (vd, pid);
        string name = sSystem::globals.get_glb_name(vd, pid, depth);
        Util::msg(2,"dp_decl_varrefs: "+name);
        dp.mk_var_decl(name,ty);
    }
}

//varrefs are in extended format: "a_2"
template<class DP>
void DP_declare_varrefs_ext ( DP& dp, const set<Varref>& vrs, Pid pid, int add_depth) {
    const_foreach(it, vrs) {
        string oname; Pid pid; int depth;
        Naming::get_orig_name_pid_depth(it->to_str(), oname, pid, depth);
        Var_dcl vd(oname);
        //typename DP::DP_type dty = sSystem::globals.get_DP_ty (dp, vd, pid);
        Ty ty = sSystem::globals.get_ty (vd, pid);
        depth += add_depth;
        string name = sSystem::globals.get_glb_name(vd, pid, depth);
        //Util::msg(2,"dp_decl_varrefs_ext: "+name);
        dp.mk_var_decl(name,ty);
    }
}

template<class DP>
struct expr_sym_eval_visitor {

    enum mode { PLAIN, TRANSLATE };
    int pid;
    int depth;
    DP& dp;
    mode m;

    typedef typename DP::expr expr;
    expr result;



    expr_sym_eval_visitor(const Expr& e, int _pid, int _depth, DP& _dp, mode _m = PLAIN)
                    : pid(_pid), depth(_depth),dp(_dp), m(_m) {
         //   Util::msg(2, "expr_sym_eval_vis : expr is "+ e.to_str());
        VAR::apply_visitor(*this,e);
    }


    void operator() (const BinOp& bop) {
        const Expr* e1 = TUP::get<0>(bop);
        op o = TUP::get<1>(bop);
        const Expr* e2 = TUP::get<2>(bop);
        const Exprt& et1 = *e1;
        const Exprt& et2 = *e2;

        expr val1;

        apply_visitor(*this,et1);
        val1 = result;
        apply_visitor(*this,et2);
        result = apply_op(o,val1, result,dp);
    }

    void operator() (const TernOp& e)  {
        op o = TUP::get<0>(e);
        CHK ( o == IteOp );
        const Expr* e1 = TUP::get<1>(e);
        const Expr* e2 = TUP::get<2>(e);
        const Expr* e3 = TUP::get<3>(e);
        const Exprt& et1 = *e1;
        const Exprt& et2 = *e2;
        const Exprt& et3 = *e3;

        apply_visitor(*this,et1);
        expr c = result;
        apply_visitor(*this,et2);
        expr t = result;
        apply_visitor(*this,et3);
        expr f = result;
        result = dp.mk_ite(c,t,f);

    }

    void operator() (const UnOp& e) {
        //Util::msg(2,"unop: ");
        uop o = TUP::get<0>(e);
        const Expr* e1 = TUP::get<1>(e);
        const Exprt& et1 = *e1;

        apply_visitor(*this,et1);
        result = apply_uop(o, result,dp);
        //DP::pp_expr(result);
    }

    void operator() (const Varref& vr) {
        //Util::msg(2,"{varref: ");
        if ( m == TRANSLATE ) {
            string oname; Pid pid; int vr_depth; 
            Naming::get_orig_name_pid_depth(vr.to_str(), oname, pid, vr_depth) ;
            int new_depth = vr_depth + depth;
            result = eval_sym_varref(dp,Varref(oname), pid, new_depth);
        }
        else result = eval_sym_varref(dp,vr, pid, depth);
        //DP::pp_expr(result);
        //Util::msg(2,"}end varref: ");
    }

    void operator() (const Const& c) {
        //DP::dump_context(ct);
        //Util::msg(2,"{const: ");
        result = dp.mk_const_expr(c);
    }

    void operator() (const Expr_Enum& ee) {
        assert(0);
    }

    void operator() (const ChanInit& ci) { //all channel inits are static
        assert(0);
    }
    template<class T>
    void operator() (const T& t) { assert(0); }

};




template<class DP>
typename DP::expr eval_sym_expr(DP& dp, const Expr* e, int pid, int depth) {
  CHK( e != NULL);
  expr_sym_eval_visitor<DP> vis(*e,pid,depth,dp);
  return vis.result;
}

template<class DP>
typename DP::expr eval_sym_expr_pair(DP& dp, const Expr* e, int pid, int depth) {
  CHK( e != NULL);
  expr_sym_eval_visitor<DP> vis(*e,pid,depth,dp, expr_sym_eval_visitor<DP>::TRANSLATE);
  return vis.result;
}

template<class DP>
typename DP::expr eval_guard_expr(DP& dp, const Guard_expr& gexpr, Pid pid, int depth) {
    typename DP::expr curr = dp.mk_true();
    //typename DP::expr tmp[2];
    const list<const Expr*>& exprs = gexpr.exprs;

    const_foreach(itl, exprs) {
        const Expr* e = *itl;
        //tmp[0] = curr;
        typename DP::expr tmp = eval_sym_expr(dp,e,pid,depth);
        curr = dp.mk_and(curr, tmp);
    }
    return curr;
}

// used both in logic eval and init eval
template<class DP>
typename DP::expr eval_sym_alist ( DP& dp, const list<Assign>& alist, Pid pid, int depth) {
    typedef typename DP::expr expr;
    expr res = dp.mk_true();
    //DP::expr a[2];
    const_foreach(it, alist) {
        const Assign& assign = *it;
        const Varref& vr = assign.get_vr();
        Var_dcl vd = vr.to_vd_plain();
        const Expr* e = assign.get_rhs();

        expr var = eval_name_expr(dp,vd,pid,depth);
        expr ex_var = eval_sym_expr(dp,e,pid,depth);
        //a[1] = dp.mk_eq(var,ex_var);
        //a[0] = res;
        //res = dp.mk_and(a,2);
        res = dp.mk_and( dp.mk_eq(var,ex_var), res );
    }
    return res;
}


template void DP_declare_varrefs ( DP& dp, const set<Varref>& vrs, Pid pid, int depth) ;
template void DP_declare_varrefs ( FociDP& dp, const set<Varref>& vrs, Pid pid, int depth) ;

template void DP_declare_varrefs_ext ( DP& dp, const set<Varref>& vrs, Pid pid, int add_depth) ;
template void DP_declare_varrefs_ext ( FociDP& dp, const set<Varref>& vrs, Pid pid, int add_depth) ;

template DP::expr eval_name_expr(DP& dp, const Var_dcl& vd, Pid pid, int depth) ;
template FociDP::expr eval_name_expr(FociDP& dp, const Var_dcl& vd, Pid pid, int depth) ;
template BDD_DP::expr eval_name_expr(BDD_DP& dp, const Var_dcl& vd, Pid pid, int depth) ;

template DP::expr eval_sym_expr(DP& dp, const Expr* e, int pid, int depth) ;
template FociDP::expr eval_sym_expr(FociDP& dp, const Expr* e, int pid, int depth) ;
template BDD_DP::expr eval_sym_expr(BDD_DP& dp, const Expr* e, int pid, int depth) ;

template DP::expr eval_sym_expr_pair(DP& dp, const Expr* e, int pid, int depth) ;
template FociDP::expr eval_sym_expr_pair(FociDP& dp, const Expr* e, int pid, int depth) ;
template BDD_DP::expr eval_sym_expr_pair(BDD_DP& dp, const Expr* e, int pid, int depth) ;

//for Guard_expr = list<Expr*>
template DP::expr eval_guard_expr(DP& dp, const Guard_expr& gexpr, Pid pid, int depth) ;
template FociDP::expr eval_guard_expr(FociDP& dp, const Guard_expr& gexpr, Pid pid, int depth) ;
template BDD_DP::expr eval_guard_expr(BDD_DP& dp, const Guard_expr& gexpr, Pid pid, int depth) ;

template DP::expr eval_sym_alist ( DP& dp, const list<Assign>& alist, Pid pid, int depth) ;
template FociDP::expr eval_sym_alist ( FociDP& dp, const list<Assign>& alist, Pid pid, int depth) ;
template BDD_DP::expr eval_sym_alist ( BDD_DP& dp, const list<Assign>& alist, Pid pid, int depth) ;


