#include"foci_dp.h"
#include"util.h"
#include<iostream>

// --- Foci variant 

//int Foci_variant::tmp_cnt = 0;

Foci_variant Foci_variant::operator + ( Foci_variant& o ) {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_sum( e, o.e );
}

Foci_variant Foci_variant::operator - ( Foci_variant& o )  {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_sub( e, o.e );
}
Foci_variant Foci_variant::mk_mul ( Foci_variant& o )  {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_mul( e, o.e );
}
/* TODO: declare vars and look at their types when get_expr_var */
Foci_variant Foci_variant::operator && ( Foci_variant& o )  {
    CHK ( is_pred() && o.is_pred() );
    /*if ( !(is_pred() && o.is_pred()) ) {
     //   cerr <<" me is "<< to_str() << "\n o is "<< o.to_str() << "\n";
        string ostr = o.to_str();
        string mestr = to_str();
        foci_pred b1,b2;
        if ( is_expr() ) b1 = foci_mk_atom_pred(mestr);
        else b1 = p;
        if ( o.is_expr() ) b2 = foci_mk_atom_pred(ostr);
        else b2 = o.p;
        return foci_mk_and ( b1, b2 );
    }*/
    return foci_mk_and (p, o.p);
}

Foci_variant Foci_variant::operator || ( Foci_variant& o )  {
    CHK ( is_pred() && o.is_pred() );
    /*if ( !(is_pred() && o.is_pred()) ) {
    //    cerr <<" me is "<< to_str() << "\n o is "<< o.to_str() << "\n";
        string ostr = o.to_str();
        string mestr = to_str();
        foci_pred b1,b2;
        if ( is_expr() ) b1 = foci_mk_atom_pred(mestr);
        else b1 = p;
        if ( o.is_expr() ) b2 = foci_mk_atom_pred(ostr);
        else b2 = o.p;
        return foci_mk_or ( b1, b2 );
    }*/
    return foci_mk_or (p, o.p);
}

/*foci_expr foci_pred_to_expr ( foci_pred& p ) {
    return foci_mk_ite ( p, foci_mk_const (1), foci_mk_const(0) );
}*/
foci_pred foci_mk_ite_pred ( foci_pred& c, foci_pred& t, foci_pred& f) {
   foci_pred nc = foci_mk_not(c);
   return foci_mk_or ( foci_mk_and(c,t), foci_mk_and(nc,f) );
}

foci_pred foci_mk_eq_pred ( foci_pred& a, foci_pred& b ) {
    //return foci_mk_and ( foci_mk_implies(a,b) , foci_mk_implies(b,a) );
    return foci_mk_or ( foci_mk_and(a,b) , foci_mk_and( foci_mk_not(b), foci_mk_not(a) ) );
}

Foci_variant Foci_variant::mk_ite ( Foci_variant& t, Foci_variant& f ) {
    if ( !(is_pred() && t.is_expr() && f.is_expr()) ) {
        //cerr <<"ite: me is "<< to_str() << "\n t is "<< t.to_str() << "\n f is "<< f.to_str() <<"\n";
        CHK ( is_pred() ) ;
        CHK ( t.is_pred() && f.is_pred() );
        return foci_mk_ite_pred( p, t.p, f.p );
        /*
        //p = foci_mk_atom_pred(to_str());
        //CHK ( t.is_pred() || f.is_pred() );
        foci_pred tp, fp;
        if ( t.is_expr() ) tp = foci_mk_atom_pred(t.to_str());
        else tp = t.p;
        if ( f.is_expr() ) fp = foci_mk_atom_pred(f.to_str());
        else fp = f.p;
        return foci_mk_ite_pred( p, tp, fp );
        */
    }
    return foci_mk_ite ( p, t.e, f.e );
}

Foci_variant Foci_variant::operator ! () { 
    //cerr << " me is "<< to_str() <<"\n";
    CHK ( is_pred() );
    /*if  ( !is_pred() ) {
        foci_pred b = foci_mk_atom_pred(to_str());
        return foci_mk_not(b);
    }*/
    return foci_mk_not( p );
}

Foci_variant Foci_variant::operator != ( Foci_variant& o )  {
    //CHK ( is_expr() && o.is_expr() );
    return ! ( *this == o );
}
Foci_variant Foci_variant::operator == ( Foci_variant& o )  {
    if ( !(is_expr() && o.is_expr()) ) {
        CHK ( is_pred() && o.is_pred() );
        //cerr <<"equality:  me is "<< to_str() << "\n o is "<< o.to_str() << "\n";
        string ostr = o.to_str();
        if ( ostr == "true" ) 
            return p;
        else if ( ostr == "false" )
            return foci_mk_not(p);
        else return foci_mk_eq_pred(p, o.p);
        /*
        CHK ( is_expr() && o.is_pred() );
        string ostr = o.to_str();
        string mestr = to_str();
        foci_pred b = foci_mk_atom_pred(mestr);
        if ( ostr == "true" ) 
            return b;
        else if ( ostr == "false" )
            return foci_mk_not(b);
        else return foci_mk_eq_pred(b, o.p);
        */
    }
    return foci_mk_eq ( e, o.e );
}

Foci_variant Foci_variant::operator <= ( Foci_variant& o ) {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_leq (e, o.e);
}
Foci_variant Foci_variant::operator < ( Foci_variant& o ) {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_lt (e, o.e);
}

Foci_variant Foci_variant::operator >= ( Foci_variant& o ) {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_geq (e, o.e);

}

Foci_variant Foci_variant::operator > ( Foci_variant& o ) {
    CHK ( is_expr() && o.is_expr() );
    return foci_mk_gt (e, o.e);
}

bool Foci_variant::interpolate ( Foci_variant& o, Foci_variant& res ) {
    CHK ( is_pred() && o.is_pred() );
    Util::msg(2,"(*****    Calling Interpolate...**) ");
    foci_pred res_p;
    Util::Timer timer; timer.start();
    bool b = foci_interpolate(p, o.p, res_p);
    res = res_p;
    timer.stop();
    Util::msg(2,"(*****   Over Calling Interpolate...**) Time taken = %f seconds ", timer.read());
    return b;
}

lbool Foci_variant::check () {
    CHK ( is_pred() );
    foci_pred res_p;
    foci_pred T = foci_mk_true();
    bool b = foci_interpolate(p, T, res_p);

    return b?l_false:l_true;
}

Foci_variant Foci_variant::shift_to_zero () {
    if ( is_pred() ) { return foci_shift_pred_to_zero(p); }
    else if ( is_expr() ) { return foci_shift_expr_to_zero(e); }
    else assert(0);
}

Foci_variant Foci_variant::elim_ite () {
    CHK ( is_pred() );
    return foci_pred_elim_ite(p);
}

// ----- FociDP ---------------

struct FociDP_Const_sym_eval {
    FociDP& dp;
    FociDP::expr v;
    
    FociDP_Const_sym_eval(const Const& c,  FociDP& _dp) : dp(_dp) { VAR::apply_visitor(*this,c);}

    void operator() (bool b) {
        if(b) v = dp.mk_true();
        else v = dp.mk_false();
    }

    void operator() (Num n) {
        v = dp.mk_num(n);
    }

    void operator() (const Bv_const& bv) {
        v = dp.mk_num( bv.getv() );
    }

    template<class T> void operator() (const T& t) {assert(0); }
};


FociDP::expr FociDP::mk_const_expr(const Const& c) { 
    FociDP_Const_sym_eval vis_c(c,*this);
    return vis_c.v;
}




/*void FociDP::create_model ( vector< pair<string,Const> >& model ) {
    assert(0);

}



void FociDP::get_model(expr err, map<string,Const>& model, int& max_d, bool generalize, assertion_id ) {
    assert(0);
}

*/

lbool FociDP::check() {
    expr res = mk_true();
    const_foreach(it, asserts) {
        res = mk_and(res, *it);
    }
    return res.check();
}

void FociDP::assertdp(expr& e) { 
    asserts.push_back(e); 
}

assertion_id FociDP::assert_retract_dp(expr& e) {
    assert(0);
    asserts.push_back(e);
    return asserts.size()-1;
}

void FociDP::mk_bmc_split (uint depth, expr& A, expr& B ) {
    CHK( trans_vec.size()+1 == err_vec.size() && depth < err_vec.size() );

    A = mk_true(); //init and r0  and .. r_d
    B = mk_true(); //r_depth+1..rn and or(err_depth+1.. err_n)
    
    expr I = get_init();
    //Util::msg(2,"A ands with init : "+ I.to_str());
    A = mk_and(A, I );
    uint i;
    for(i=0; i< depth && i<trans_vec.size(); i++) {
      //  Util::msg(2,"A ands with trans_vec["+int2str(i)+"] = "+ trans_vec[i].to_str());
        A = mk_and(A, trans_vec[i]);
    }

    for(; i< trans_vec.size(); i++) {
        //Util::msg(2,"B ands with trans_vec["+int2str(i)+"] = "+ trans_vec[i].to_str());
        B = mk_and(B, trans_vec[i]);
    }
    expr Be = mk_false();
    if ( depth > 10 ) {
        for(i=depth; i<err_vec.size(); i++) {
            //Util::msg(2,"Be ors with err_vec["+int2str(i)+"] = "+ err_vec[i].to_str());
            Be = mk_or(Be, err_vec[i]);
        }
    }
    else 
        Be = err_vec[err_vec.size() -1];
    B = mk_and(B,Be);
}

/*bool FociDP::interpolate ( expr& A, expr& B, expr& A_ ) {
    return A.interpolate(B,A_);
}*/

bool FociDP::interpolate ( int depth, expr& A_ ) {
    expr A, B;
    mk_bmc_split(1,A,B);
    //Util::msg(2,"interpolating "+ A.to_str() +" and\n" + B.to_str());
    return A.interpolate(B,A_);
}

