#include"naming.h"

void Naming::get_orig_name_pid_depth(const string& name, string& oname, Pid& pid, int& depth) {
    size_t name_begin_pos = 0;
    if ( name.find("__t") == 0 ) {
        name_begin_pos = name.find("_",3);
        CHK( name_begin_pos > 3 );
        string pid_str = name.substr (3, name_begin_pos );
        pid = atoi(pid_str.c_str());
        name_begin_pos++;
        //    Util::message(2,"pid is %d\n",pid);
    } else pid = -1;

    size_t name_end_pos = name.rfind("_");
   // Util::message(2,"name_end_pos=%d, name[name_end_pos] = %c\n",name_end_pos,name[name_end_pos]);
    CHK( name_end_pos != string::npos );
    CHK ( name_begin_pos < name_end_pos );
    //oname = name.substr(name_begin_pos, name_end_pos);
    for(size_t i = name_begin_pos; i < name_end_pos; ++i)
        oname.append(1,name[i]);
   // Util::msg(2,"oname is "+oname);
    string depth_str = name.substr(name_end_pos+1,string::npos);
    depth = atoi (depth_str.c_str());
    //Util::message(2,"depth is %d\n",depth);
}

string Naming::get_glb_name(const string& oname, Pid pid, int depth) {
    if( pid != -1 ) {
        return get_prefix(pid) + oname + get_suffix(depth);
    }
    else return oname + get_suffix(depth);
}

bool Naming::is_st_var_name ( const string& name ) {
    /* TODO: make it robust; can't detect vars with ST in them */

    if ( name.find("ST") != string::npos ) {
       // Util::msg(2, name + " is a st var");
        return true;
    }
    else return false;
}


bool Naming::is_global_name ( const string& name ) {
    if ( name.find("__t") == 0 ) return false;
    else return true;
}
