#include"stmts.h"
#include"action.h"
#include<ctype.h>
#include<stdlib.h>

//typedef VAR::variant<Const,Varref> Recv_arg;
struct Recv_arg_is_const {
    bool tf;
    void operator() (const Const& n) { tf = true;}
    void operator() (const Varref& vr) { tf = false;}
};

bool Recv_arg::is_const() const {
  Recv_arg_is_const vis;
  VAR::apply_visitor(vis, *this);
  return vis.tf;
}

struct Recv_arg_to_str {
    string s;
    void operator() (const Const& c) { s = c.to_str();}
    void operator() (const Varref& vr) { s = vr.to_str();}
};

string Recv_arg::to_str() const {
  Recv_arg_to_str vis;
  VAR::apply_visitor(vis, *this);
  return vis.s;
}



//FIX? : assumption is that no variable has the same name as a mtype constant
//the best fix is :
//add a type mtype_const(string) to Const
//post_process a system to change all mtype expressions to mtype_const
/*
bool is_varref_mtype(const Varref& vr, const Mtype_map& mtype_indices) {
	return ( mtype_indices.find(vr.to_str()) != mtype_indices.end() ) ;
}

int eval_varref_mtype(const Varref& vr, const Mtype_map& mtype_indices) {
	return ( mtype_indices.find(vr.to_str())->second ) ;
}

bool Send_arg::is_mtype(const Mtype_map& mtype_indices) const {
	Varref vr;
	if( !e->is_varref(vr) ) return false;
	return is_varref_mtype(vr,mtype_indices); 
}

Varref Send_arg::get_mtype_varref() const {
	Varref vr;
	CHK(e->is_varref(vr));
	return vr;
}
int Send_arg::get_mtype_val(const Mtype_map& mtype_indices) const {
	return eval_varref_mtype( get_mtype_varref(), mtype_indices);
}

*/





//---------------- get_from_str


void get_varref_from_str(const string& var_name, Varref& vr) {
	assert( var_name.find('[') == string::npos ); // no array names allowed for now
	vr = Varref(SymbolRef(var_name));
}


Assign get_assign_from_str(const string& str) {
	size_t pos = str.find('=');
	string var_name = str.substr(0,pos);
	Varref vr; get_varref_from_str(var_name, vr);
	string expr_str = str.substr(pos+1);
	assert(0); //convert expr str to expr
}

void Tokenize(const string& str,
                      vector<string>& tokens,
                      const string& delimiters = " ")
{
    // Skip delimiters at beginning.
    string::size_type lastPos = str.find_first_not_of(delimiters, 0);
    // Find first "non-delimiter".
    string::size_type pos     = str.find_first_of(delimiters, lastPos);

    while (string::npos != pos || string::npos != lastPos)
    {
        // Found a token, add it to the vector.
        tokens.push_back(str.substr(lastPos, pos - lastPos));
        // Skip delimiters.  Note the "not_of"
        lastPos = str.find_first_not_of(delimiters, pos);
        // Find next "non-delimiter"
        pos = str.find_first_of(delimiters, lastPos);
    }
}


void get_send_args_from_str(const string& str, Send_args& sas) {
	string s;
	vector<string> tokens;
	Tokenize(str,tokens,", ");
	for(size_t j =0; j< tokens.size(); ++j) {
		string s = tokens[j];
		for(size_t i =0; i < s.size(); ++i)
			assert( isalnum(s[i]) ); //only alphabet or char, no complicated expressions
		Varref vr; get_varref_from_str(s,vr);
		Send_arg sa(vr);
		sas.push_back(sa);
	}
}


Send get_send_from_str(const string& str) {
	size_t pos = str.find('!');
	string var_name = str.substr(0,pos);
	Varref vr; get_varref_from_str(var_name, vr);

	string send_args_str = str.substr(pos+1);
	Send_args sas; get_send_args_from_str(send_args_str, sas);
	return Send(vr,sas);
}

void get_recv_args_from_str(const string& str, Recv_args& ras) {
	string s;
	vector<string> tokens;
	Tokenize(str,tokens,", ");
	for(size_t j =0; j< tokens.size(); ++j) {
		string s = tokens[j];
		bool is_a_const = true;
		for(size_t i =0; i < s.size(); ++i) {
			assert( isalnum(s[i]) ); //only alphabet or char, no complicated expressions
			if( !isdigit(s[i]) ) is_a_const = false;
		}

		if( is_a_const ) {
			Const c(atoi(s.c_str()));
			Recv_arg ra(c);
			ras.push_back(ra);
		}
		else {
			Varref vr; get_varref_from_str(s,vr);
			Recv_arg ra(vr);
			ras.push_back(ra);
		}
	}
}
Recv get_recv_from_str(const string& str) {
	size_t pos = str.find('!');
	string var_name = str.substr(0,pos);
	Varref vr; get_varref_from_str(var_name, vr);

	string recv_args_str = str.substr(pos+1);
	Recv_args ras; get_recv_args_from_str(recv_args_str, ras);
	return Recv(vr,ras);
}


