#ifndef _SYMTAB_H
#define _SYMTAB_H

#include"ast.h"
#include"expr.h"

class Value_type{
    public:
        Ty ty; string s;
        Value_type() {}
        Value_type(const Ty& _ty, const string& _s) : ty(_ty), s(_s) {}
        const Ty& get_ty() const { return ty; }
} ;

class Symtab {
    private:
        typedef map<Var_dcl,Value_type > Map_type;
        Map_type vars; //a[0] -> (int, global)
        map<Symbol, set<Symbol> > type_decls;
        set<Var_dcl> glb_vars;

        //typedef map<Var_dcl,ChanInit> Chan_map;
        //Chan_map chans; //Var_dcl to TUP::tuple<Num,Ty_list>


        Ty get_var_type(const Var_dcl& vd) const { 
            CHK( has_var(vd) ); 
            return vars.find(vd)->second.get_ty();
        }
        
        /*Ty get_chanvar_type( const Var_dcl& vd) const {
            CHK ( check_chanvar_exists(vd) );
            const ChanInit& ci = chans.find(vd)->second;
            const Ty_list& ty_list = TUP::get<0>(ci);
            CHK( ty_list.size() == 1);
            return *(ty_list.begin());
        }*/

        //string get_scope(const Var_dcl& vd) { return (get_it(vd)).s;}

    public:


        void insert(const Var_decl& d, const string& scope="G") {
            Ty ty = TUP::get<0>(d);  
            const Varspec& vs = TUP::get<1>(d);  
            const Var_dcl& vd = TUP::get<0>(vs);
            Value_type v(ty,scope);
            vars[vd]=v;
        }

        void insert(const Var_dcl& vd, Ty ty ) {
            Value_type v(ty,"L");
            vars[vd] = v;
        }

        void insert_type(const Type_decl& td) {
            Symbol ty_name = TUP::get<0>(td);
            const Symbol_list& ty_vals = TUP::get<1>(td);

            set<Symbol> ty_vals2;
            copy(ty_vals.begin(), ty_vals.end(), inserter(ty_vals2, ty_vals2.begin()) );
            type_decls[ty_name] = ty_vals2;
        }

        //void insert_chan_var(const Var_dcl& vd, const ChanInit& ci ) { chans[vd] = ci; }
        bool has_var(const Var_dcl& vd) const { return (vars.find(vd) != vars.end()); }

        Ty get_type(const Var_dcl& vd) const { 
            Ty ty;
            CHK( has_var(vd) );
            ty = get_var_type(vd); 
            return ty;
        }


        void get_range_values (const Var_dcl& vd, list<Const>& clist) const {
            Ty ty = get_type(vd);
            get_ty_values(ty, clist);
        }

        bool is_ev(const Var_dcl& vd) { return is_ty_ev(get_type(vd));}

        const set<Var_dcl>& get_glb_vars() { 
            if( glb_vars.empty()) {
                for(Map_type::const_iterator it= vars.begin(); it!= vars.end(); ++it) {
                    //if( !is_ev(it->first) )
                        glb_vars.insert(it->first);
                }
            }
            return glb_vars;
        }

        const set<Var_dcl>& get_all_glb_vars() {
         /*   if ( all_glb_vars.empty() ) {
                foreach(it, vars) { all_glb_vars.insert(it->first); }
                foreach(it, chans) { all_glb_vars.insert(it->first); }
            }*/
            return get_glb_vars();
        }

        friend class CFG_comp;
        template<class> friend class Systemt;
        //template<class T> friend class Systemt <T>;

};
#endif
