#include"sys_expl.h"

void Proc_explorer::get_enabled_acts_cfg_X(const Sys_state& s, list<Proc_edge>& en_acts) const {
        int pc = s.get_pcval (pid);
        list< CFG_edge > en_edges;
        c->get_out_edges(pc, en_edges);

        /* handle else statements */
        bool exists_one_guard = false, has_else_guard = false;
        CFG_edge else_edge;

        foreach(it, en_edges) {
            //eval guard
            Util::msg(5,"Checking edge "+it->to_str()+"\n");
            //might be better to do it at preproc stage: fix else and share expression
            if ( it->has_else_guard() ) { has_else_guard = true; else_edge = *it; continue;}
            tbool lb = eval_guard_cfg_edge(s, *it, pid) ;
            if( lb.is_f() ) continue;
            if (lb.is_t() ) exists_one_guard = true;
            

            if( !it->is_comm_type() ) { /* push in non-comm statements at beginning */
                Proc_edge pe (*it, pid);
                en_acts.push_back(pe);
                continue;
            }

            if( !eval_cfg_edge_chan_act_enabled(*it, s, pid) ) continue;

            //CONCRETIZE send (evaluate) and recv ( do nothing)
            concretize_cfg_edge(*it,s,pid);
            Proc_edge pe (*it, pid);
            Util::msg(5,"Pushing pe "+pe.to_str()+"\n");
            en_acts.push_back(pe);
        }

        if( !exists_one_guard && has_else_guard ) {
            Proc_edge pe (else_edge, pid);
            Util::msg(5,"Pushing pe "+pe.to_str()+"\n");
            en_acts.push_back(pe);
        }
}


void Proc_explorer::get_enabled_acts_cfg(const Sys_state& s, list<Proc_edge>& en_acts) const {
        int pc = s.get_pcval (pid);
        list< CFG_edge > en_edges;
        c->get_out_edges(pc, en_edges);

        /* handle else statements */
        bool exists_one_guard = false, has_else_guard = false;
        CFG_edge else_edge;

        foreach(it, en_edges) {
            //eval guard
            Util::msg(5,"Checking edge "+it->to_str()+"\n");
            //might be better to do it at preproc stage: fix else and share expression
            if ( it->has_else_guard() ) { has_else_guard = true; else_edge = *it; continue;}
            tbool lb = eval_guard_cfg_edge(s, *it, pid) ;
            if( lb.is_f() ) continue;
            if ( !lb.is_t() ) assert(0);
            exists_one_guard = true;

            if( !it->is_comm_type() ) { /* push in non-comm statements at beginning */
                Proc_edge pe (*it, pid);
                en_acts.push_back(pe);
                continue;
            }

            if( !eval_cfg_edge_chan_act_enabled(*it, s, pid) ) continue;

            //CONCRETIZE send (evaluate) and recv ( do nothing)
            concretize_cfg_edge(*it,s,pid);
            Proc_edge pe (*it, pid);
            Util::msg(5,"Pushing pe "+pe.to_str()+"\n");
            en_acts.push_back(pe);
        }

        if( !exists_one_guard && has_else_guard ) {
            Proc_edge pe (else_edge, pid);
            Util::msg(5,"Pushing pe "+pe.to_str()+"\n");
            en_acts.push_back(pe);
        }
}

//check if guard is true; send, recvs on len-0 queues are always enabled,
void Proc_explorer::get_enabled_acts (const Sys_state & s, list < Proc_edge > &en_acts) const
{
assert(0);
    if(expl_type == _CFG_) {
        get_enabled_acts_cfg_X(s,en_acts);
    }

    else if(expl_type == _CFA_) {

        const CFA_state& curr_state = s.get_cfa_state(pid);
        list<eCFA_edge> en_edges;
        fa.get_out_edges(curr_state, en_edges);
        foreach(it, en_edges) {
            //check if the inputs match with s
            if( !eval_guard_cfa_edge(s, *it, pid) ) continue;
            Proc_edge pe(*it, pid);
            en_acts.push_back(pe);
        }

    }
    else CHK(0);
}
