#include"sys_expl_sym.h"
#include"bdd_dp.h"

void Proc_explorer_sym::get_enabled_acts_cfg_X(const Sys_state& s, list<Proc_edge>& en_acts) const {
}



//check if guard is true; send, recvs on len-0 queues are always enabled,
void Proc_explorer_sym::get_enabled_acts (const Sys_state & s, list < Proc_edge > &en_acts) const
{
}

bool Sys_expl_sym::check_err_reach () {
    for(uint i= fa_start_index; i<procs.size(); i++) {
        if ( ! procs[i].has_final() ) return false;
    }
    return true;
}

void Sys_expl_sym::gen_ce( DP& dp, bool gen, DP::expr err, sSys_CE& ce, assertion_id err_id) {
    map<string,Const> model;
    int maxdepth = -1;
    dp.get_model(err,model,maxdepth,gen, err_id);
    CHK ( maxdepth != -1 );

    map<int, sCFA_act> pos2act;
    //order acc to suffixes
    const_foreach(it, model) {
        const string& name = it->first;
        Const val = it->second;
        //Util::msg(1,"model has "+name+" = "+val.to_str());
        string oname; Pid pid; int depth;
        Naming::get_orig_name_pid_depth(name, oname, pid, depth);
        CHK ( depth <= maxdepth );
       // Util::msg(2,"decomp oname = " + oname +", pid = "+ int2str(pid) + ", depth = "+int2str(depth));
        //Timer t; t.start();
        if ( Naming::is_st_var_name(name) ) continue;
        pos2act[depth].add_val(0, pid, Varref(oname), val );
        //t.stop(); Util::message(2,"t = %f\n",t.read());
    }


    if ( maxdepth == 0 ) {
        sCFA_act dummy;
        sSys_act act ( pos2act[0], dummy );
        ce.append(sSys_edge(act));
        Util::message(1,"pos2act%d = %s",0,pos2act[0].to_str().c_str());
    }

    for(int i=0; i<maxdepth; i++ ) {
        //if ( !Key_In_Bag(i, pos2act) ) continue;
        bool has_i = Key_In_Bag(i,pos2act);
        bool has_ii = Key_In_Bag(i+1,pos2act);
        if ( !(has_i || has_ii) ) {
            sCFA_act dummy;
            sSys_act act(dummy, dummy);
            ce.append(sSys_edge(act));
            Util::message(1,"making dummy action for i=%d\n",i);
        }
        else {
            sCFA_act dummy;
            if ( !has_i ) pos2act[i] = dummy;
            if ( !has_ii ) pos2act[i+1] = dummy;
            if ( i == 0 )
                Util::message(1,"pos2act%d = %s",i,pos2act[i].to_str().c_str());
            Util::message(1,"pos2act%d = %s",i+1,pos2act[i+1].to_str().c_str());
            sSys_act act ( pos2act[i], pos2act[i+1]);
            Util::msg(2,"sys act is"+act.to_str());
            ce.append(sSys_edge(act));
        }
    }

    Util::msg(1,"gen_ce : ce is "+ce.to_str_const());

}



bool Sys_expl_sym::check_err(DP& dp, const sPropDFA& P, int depth, bool must_gen_ce, bool gen, sSys_CE& ce) {
    DP::expr err = get_err_f(dp,depth,P);
    //dp.push();
    //dp.assertdp(err);
    assertion_id err_id = dp.assert_retract_dp(err);

    if ( dp.check() == l_true ) {
        //  Util::msg(2,"check_prop::CE::show_sat"); dp.show_sat();
        if ( must_gen_ce ) { 
            gen_ce(dp, gen, err, ce, err_id); 
        }
        return true;
    }
    else  {
        //dp.pop(); 
      //  dp.assertdp(dp.mk_not(err));

        dp.retract(err_id);
        //dp.assert_retract_dp(dp.mk_not(err));
        return false;
    }
}


bool Sys_expl_sym::check_fix_point_plain(DP& dp, int depth) {
    bool retval = false;
    DP::expr res = get_uniq(dp,depth);

    assertion_id id = dp.assert_retract_dp(res);
    if ( dp.check() == l_false ) {
        retval = true;
        Util::msg(4,"check_fix_point : context inconsistent");
        dp.retract(id);
    }
    else {
        Util::message(2,"check_fix_point : depth = %d is sat:\n",depth);
       // dp.show_sat();
    }
    return retval;
}

bool Sys_expl_sym::check_fix_point(DP& dp, const sPropDFA& P, int depth) {
    bool retval = false;
    DP::expr res = get_uniq(dp,depth);

    /*DP::expr init_c = get_init_states_P(dp,P,depth);
    DP::expr neg_init_c = dp.mk_not(init_c);
    res = dp.mk_and(res,neg_init_c);
    */
    
    //dp.push();
    //dp.assertdp(res);
    assertion_id id = dp.assert_retract_dp(res);
    //if ( dp.inconsistent() )  {
    if ( dp.check() == l_false ) {
        retval = true;
        Util::msg(4,"check_fix_point : context inconsistent");
        //dp.pop();
        dp.retract(id);
    }
    else {
        //dp.pop();
        //dp.assertdp(res);
        Util::message(2,"check_fix_point : depth = %d is sat:\n",depth);
        //dp.show_sat();
    }
    return retval;
}

bool Sys_expl_sym::check_step(DP& dp, const sPropDFA& P, int depth) {
    CHK ( depth > 0 );

    Util::message(3,"check_step : Exploring depth %d\n",depth);
    if ( ! check_err_reach()  ) { //TODO properly
        return true;
    }

    if ( depth == 1) {
        // !P0
        declare_vars_P(dp,0,P);

        DP::expr err = get_err_f(dp,0,P);
        dp.assertdp(dp.mk_not(err));
        //dp.assertdp(err);
        //return false;
    }
    //else {
        //(T01 /\ P0) /\ !P1
        //(T01 /\ P0) /\ (T12 /\ P1) /\ !P2

        DP::expr res = dp.mk_true();
        declare_vars_P(dp,depth,P);
        // build T (depth-1,depth)
        for(uint i=0; i<procs.size(); ++i) {
            //cfg_explore or cfa_explore: add constraints 
            res = dp.mk_and(res, procs[i].explore(dp,depth-1) );
        }
        res = dp.mk_and( res, get_prop_trans_f(dp,P,depth-1) );
        //build uniq(i,depth)
        DP::expr uniq = get_uniq (dp,depth);
        res = dp.mk_and(res,uniq);

        DP::expr init_c = get_init_states_P(dp,P,depth);
        DP::expr neg_init_c = dp.mk_not(init_c);
        res = dp.mk_and(res,neg_init_c);
        

        dp.assertdp(res);
        DP::expr err = get_err_f(dp,depth,P);
        DP::expr nerr = dp.mk_not(err);

        dp.push();
        dp.assertdp(err);
        //dp.assertdp( dp.mk_and(res,nerr) );

        if ( dp.check() != l_false ) {
            //CHK( dp.check() == l_true );
            //dp.show_sat();
            dp.pop();
            dp.assertdp(nerr);
            return false;
        }
        else { 
            //dp.pop(); 
            return true; 
        }

    //}

}



bool Sys_expl_sym::check_base (DP& dp, const sPropDFA& P, sSys_CE& ce, int depth, int err_depth, bool must_gen_ce, bool gen ) {
    if ( depth == 0) {
        declare_vars_P(dp,0,P);
        DP::expr res = get_init_states_P(dp,P);
        dp.set_init_constraint(res);
        dp.assertdp(res);
        //dp.assert_retract_dp(res);
        
        bool err_occ = false;
        //if (err_depth != -1 && depth != err_depth) return !err_occ;
        err_occ = check_err(dp,P,0,must_gen_ce,gen,ce);
        return !err_occ;

        // return true;
    }
    else {

        Util::message(2,"Exploring depth = %d\n",depth);
        DP::expr res = dp.mk_true();
        declare_vars_P(dp,depth,P);
        // cfa vars are declared in cfa_explore
        for(uint i=0; i<procs.size(); ++i) {
            //cfg_explore or cfa_explore: add constraints 
            Util::message(3,"Exploring proc pid %d\n",i);
            res = dp.mk_and(res, procs[i].explore(dp,depth-1) );
        }

        res = dp.mk_and( res, get_prop_trans_f(dp,P,depth-1) );
        dp.assertdp(res);
        //dp.assert_retract_dp(res);
        //CHK ( dp.check() == l_true ) ;
        bool err_occ = false;
        //if (err_depth != -1 && depth != err_depth) return !err_occ;
        err_occ = check_err(dp,P,depth,must_gen_ce,gen,ce);
        return !err_occ;
    }
}

bool Sys_expl_sym::check_interpolant_fp(FociDP& dp, const sPropDFA& P, int depth, int start_depth) {

    declare_vars_P(dp,depth,P);
    FociDP::expr err = get_err_f(dp,depth,P);
    dp.set_err(depth,err);
    //dp.assertdp(err);

    if ( depth == 0 ) {
        FociDP::expr I = get_init_states_P(dp,P);
        dp.set_init(I);
     //   dp.assertdp(OI);
        return false;
    }
    else {
        Util::message(2,"check_interpolant: Exploring depth = %d\n",depth);
        FociDP::expr res = dp.mk_true();
        //declare_vars_P(dp,depth,P);
        // cfa vars are declared in cfa_explore
        for(uint i=0; i<procs.size(); ++i) {
            //cfg_explore or cfa_explore: add constraints 
            Util::message(3,"Exploring proc pid %d\n",i);
            res = dp.mk_and(res, procs[i].explore(dp,depth-1) );
            //Util::msg(2,"proc is "+ procs[i].explore(dp,depth-1).to_str());
        }

        FociDP::expr pres = get_prop_trans_f(dp, P, depth-1);
        //Util::msg(2,"pres is "+pres.to_str());
        res = dp.mk_and( res, pres );
        dp.set_trans(depth-1,res);
      //  dp.assertdp(res);

        if ( depth < start_depth ) {
            Util::msg(2,"Below start depth..not computing interpolant");
            return false;
        }

        FociDP::expr I = dp.get_init(); 
        FociDP::expr OI = I;

        uint intp_it = 0;

        while ( true ) {
            intp_it ++;
            FociDP::expr intp;
            Util::msg(2,"Interpolating....iteration = "+int2str(intp_it));
            bool unsat = dp.interpolate(1,intp); //at depth 1 from OI
            if ( intp_it == 1 ) {
                CHK ( unsat );
            }
            if( !unsat ) {
                Util::msg(2,"BMC is sat..no interpolant");
                dp.set_init(I);
                return false;
            }
            //rename vars in intp to 0
            intp = intp.shift_to_zero();
           // Util::msg(2,"(*****   Interpolant is " + intp.to_str() + " *****)");
            Util::msg(2,"(*****   Interpolant found.  *****)");
            FociDP tmp_dp;
            declare_vars_P(tmp_dp,0,P);
            FociDP::expr neg_OI = tmp_dp.mk_not(OI);
            FociDP::expr is_fp = tmp_dp.mk_and(intp,neg_OI);
            Util::msg(2,"---**** Checking if fixpoint reached.. ****---");
            tmp_dp.assertdp(is_fp);
            if ( tmp_dp.check() == l_true ) {
                Util::msg(2,"---- Fixpoint not reached..trying again..---");
                OI = dp.mk_or(OI,intp);
                dp.set_init(OI);
            }
            else {
                dp.set_init(I);
                return true;
            }
        }
    }

}

bool Sys_expl_sym::check_bdd_prop(const sPropDFA& P, sSys_CE& ce) {
    BDD_DP bdd_dp; 
    uint depth = 1;
    declare_vars_P(bdd_dp,depth-1,P,false);
    declare_vars_P(bdd_dp,depth,P,false);
    BDD_DP::expr I = get_init_states_P(bdd_dp,P);
    bdd_dp.set_init(I);
    BDD_DP::expr err = get_err_f(bdd_dp,depth-1,P);
    bdd_dp.set_err(depth-1,err);

    //BDD_DP::expr res = bdd_dp.mk_true();
    for(uint i=0; i<procs.size(); ++i) {
        Util::message(3,"Exploring proc pid %d\n",i);
        bdd_dp.add_trans(procs[i].explore(bdd_dp,depth-1));
     //   res = bdd_dp.mk_and(res, procs[i].explore(bdd_dp,depth-1) );
        //Util::msg(2,"proc is "+ procs[i].explore(bdd_dp,depth-1).to_str());
    }

    BDD_DP::expr pres = get_prop_trans_f(bdd_dp, P, depth-1);
    //res = bdd_dp.mk_and( res, pres );
    //bdd_dp.set_trans(depth-1,res);
    bdd_dp.add_trans(pres);
    
    int err_depth = -1;
    bool err_res = bdd_dp.check_err_reach(err_depth);
    if (!err_res) {
        Util::msg(2,"BDD_fix_pt: Property holds");
        return true;
    }
    Util::msg(2,"BDD_fix_pt: Err found at depth "+int2str(err_depth));
    bool base_ret; 
    DP ydp;
    for(int depth=0; depth<=err_depth; depth++) {
        base_ret = check_base(ydp,P,ce,depth,err_depth,true,false);
        if( !base_ret ) break;
    }
    CHK( !base_ret );
    return false;
}

bool Sys_expl_sym::check_prop(const sPropDFA& P, sSys_CE& ce, bool must_gen_ce, bool gen, bool fixpt) {
    DP dp_step;
    FociDP dp_ip;
    int max_depth = sys.get_depth();
    //if (fixpt) return check_bdd_prop(P,ce);
    //if ( fixpt ) mem.show_pid2stvars();
    for(int depth=0; ; ++depth) {
        if ( max_depth != -1 ) CHK(!fixpt);
        if ( max_depth != -1 && depth > max_depth) {
            Util::message(2,"Explore over..max depth %d reached.\n",max_depth);
            break;
        }
        Util::message(2,"----------------------   Now Exploring depth %d -----------------------\n",depth);
        bool base_ret = check_base(dp_base,P,ce,depth,max_depth,must_gen_ce,gen);
        if ( !base_ret ) return false;
        //if ( depth == 0 ) continue;
       // fixpt = false;

        if ( fixpt ) {
            //if ( depth > 7 ) return true;
            bool ret1 = check_step(dp_step,P,depth+1);
            bool ret2 = false;
            /*if ( depth > 0 )
                ret2 = check_fix_point(dp_base,P,depth) ; 
            else ret2 = false;
            */
            bool ret3 = false;
            ret3 = check_interpolant_fp(dp_ip,P,depth,0); 
            if (ret1 || ret2 || ret3) {
            //    CHK( check_bdd_prop(P,ce) );
                if ( ret1  && ret2 && ret3) { Util::msg(2,"none wins"); }
                if ( ret1 ) { Util::msg(2,"step wins"); }
                if ( ret2 ) { Util::msg(2,"fixpoint wins"); }
                if ( ret3 ) { Util::msg(2,"interpolant wins"); }
                Util::msg(2,"Fixpoint reached..explore over.");
                break;
            } 
        }
       // getchar();
    }
    return true;
}

// =========== All SAT ...

void compute_all_models_act ( DP& dp, int adepth, sCFA_act& res_act ) {
    list< map<string,Const> > models;
    dp.get_all_models(models,true);
    set<sCFA_act> acts;

    const_foreach(it1, models) {
        const map<string,Const>& model = *it1;
        map<int, sCFA_act> pos2act;
        Util::msg(2,"new model..");
        const_foreach(it, model) {
            const string& name = it->first;
            Const val = it->second;
            //Util::msg(1,"model has "+name+" = "+val.to_str());
            string oname; Pid pid; int depth;
            Naming::get_orig_name_pid_depth(name, oname, pid, depth);
            //Util::msg(2,"decomp oname = " + oname +", pid = "+ int2str(pid) + ", depth = "+int2str(depth));
            //Timer t; t.start();
            if ( depth == adepth || depth == adepth + 1 ) {
                Util::msg(2,"Adding for depth= "+int2str(depth) +", "+oname+" = "+val.to_str());
                pos2act[depth].add_val(0, pid, Varref(oname), val );
            }
            //t.stop(); Util::message(2,"t = %f\n",t.read());
        }
        sSys_act sact ( pos2act[adepth], pos2act[adepth+1]);
        sCFA_act act, act2 = sact;
        act2.abstract_to_globals(act);
        Util::msg(2,"act is "+act.to_str());
        acts.insert(act);
    }
    sCFA_act::union_set(acts,res_act);
}



// ================  Generalizing split etc ..



void Sys_expl_sym::lift_act_vars_unsat ( DP& dp, const sCFA_act& ceA, int adepth, sCFA_act& split_act) {
    DP dp_tmp;

    sCFA_trace ceAt; ceAt += sCFA_edge(ceA);
    declare_vars(dp_tmp,adepth);
    declare_vars(dp_tmp,adepth+1);
    DP::expr ceAe = fa_get_trace_f( dp_tmp, ceAt, adepth );
    dp_tmp.assertdp(ceAe);
    list< map<string,Const> > models;
    dp_tmp.get_one_model(models, true); //only globals vals
    //CHK ( models.size() == 1 );
    map<string,Const>& model = *( models.begin() );
    map<string,Const> lifted_model;
    dp.lift_model_vars_unsat(model, lifted_model);

    split_act = sCFA_act();
    const_foreach(it, lifted_model) {
        const string& name = it->first;
        Const val = it->second;
        string oname; Pid pid; int depth;
        Naming::get_orig_name_pid_depth(name, oname, pid, depth);
        CHK ( pid == -1 );
        if ( depth == adepth ) {
            split_act.add_val(0, pid, Varref(oname), val );
        }
        else if (depth == adepth + 1 ) {
            split_act.add_val(1, pid, Varref(oname), val );
        }
        else assert(0);
    }

}


bool Sys_expl_sym::generalize_split (const sPropDFA& P, const sCFA_trace& u, const sCFA_trace& v, const sCFA_act &A, 
                                sCFA_act& split_act ) {

    sCFA_act ceA = split_act;
    Util::msg(2,"begin Sys_expl_sym::gen_split: u = "+u.to_str_const()+",\n A is "+A.to_str_const()+",\n v is "+v.to_str_const()+",\n ceA is "+ceA.to_str_const() );

    uint total_depth = u.size() + v.size() + 1;
    int udepth = 0;
    int adepth = u.size();
    int vdepth = adepth + 1;

    DP dp;
    // build trans relation
    declare_vars_P(dp,udepth,P);
    DP::expr res = get_init_states_P(dp,P);
    dp.set_init_constraint(res);
    dp.assertdp(res);

    for(uint depth = 1; depth <= total_depth; ++depth) {
        DP::expr res = dp.mk_true();
        declare_vars_P(dp,depth,P);
        // cfa vars are declared in cfa_explore
        for(uint i=0; i<procs.size(); ++i) {
            //cfg_explore or cfa_explore: add constraints 
            Util::message(3,"Exploring proc pid %d\n",i);
            res = dp.mk_and(res, procs[i].explore(dp,depth-1) );
        }

        res = dp.mk_and( res, get_prop_trans_f(dp,P,depth-1) );
        dp.assertdp(res);
    }

    //----

    DP::expr vexpr = fa_get_trace_f (dp, v, vdepth);
    dp.assertdp(vexpr);
    CHK ( dp.check() == l_true );
    DP::expr err = get_err_f(dp,total_depth,P);
    dp.assertdp(err);

    CHK ( dp.check() == l_true );

    Util::msg(2,"u is"+ u.to_str_const() + "\nv is "+v.to_str_const());
    DP::expr uexpr = fa_get_trace_f (dp, u, udepth);
    dp.assertdp(uexpr);
    CHK ( dp.check() == l_true );

    /*sCFA_trace At; At += sCFA_edge(A);
    DP::expr Ae = fa_get_trace_f( dp, At, adepth );
    */
    
    sCFA_trace ceAt; ceAt += sCFA_edge(ceA);
    DP::expr ceAe = fa_get_trace_f( dp, ceAt, adepth );

    //----
    
    /* check ceA - unsat (1) */
    dp.push();
    dp.assertdp(ceAe);
    CHK ( dp.check() == l_false );
    dp.pop();
    CHK ( dp.check() == l_true );

    /* check A - sat (0) ; keep it for compute_all_models */
    //dp.assertdp(Ae);
    //CHK ( dp.check() == l_true );

    split_act = sCFA_act();
    //compute_all_models_act(dp, adepth, split_act );
    lift_act_vars_unsat(dp, ceA, adepth, split_act); 


    Util::msg(2,"end Sys_expl_sym::gen_split: split_act is "+split_act.to_str());
    return true;
}
