#ifndef SYS_EXPL_SYM_H
#define SYS_EXPL_SYM_H

/*#include"path.h"
#include"upd_map.h"
*/
#include"eval_ea_sym.h"
#include"proc_edge.h"
#include"ssystem.h"
#include"sys_state.h"
#include"sys_fa.h"
#include"prop_fa.h"
#include"cfa_util.h"
#include"foci_dp.h"


class Proc_explorer_sym
{
    protected:
        //typedef sSystem::CFG_comp CFG_comp;
        //const sSystem* sys;
        const CFG_comp* c;
        sCFA_comp fa;
        Pid pid;
        //const Mem_map* mem;

        enum Expl_type {_CFG_, _CFA_};
        Expl_type expl_type;

        typedef int ID_upd_map;
        //typedef State_diff_pair<ID_diff> St_IDs_pair;



    public:
        Proc_explorer_sym (const CFG_comp* _c):  c (_c) 
        {
            expl_type = _CFG_;
            pid = c->get_pid();
        }

        Proc_explorer_sym ( const sCFA_comp& _fa): fa (_fa)
        {
            c = NULL; expl_type = _CFA_;
            pid = fa.get_pid();
        }

        Pid get_pid () const {  return pid; }

        Local_val get_init_pcval() const { 
            CHK(expl_type == _CFG_);
            return c->get_main_entry_pcval();

        }

        void get_enabled_acts_cfg_X(const Sys_state& s, list<Proc_edge>& en_acts) const ;
        void get_enabled_acts_cfg(const Sys_state& s, list<Proc_edge>& en_acts) const ;
        //check if guard is true; send, recvs on len-0 queues are always enabled,
        void get_enabled_acts (const Sys_state & s, list < Proc_edge > &en_acts) const;

        const CFA_state& get_init_cfa_state() const {
            /*const CFA_state inits = fa.get_init(); 
              CHK(inits.size() == 1);
              return *(inits.begin());
             */
            return fa.get_init();
        }

        // run initialization sequence
        /*void get_init_diff(Sys_state& start_st, Sys_state& init_st) {
            if ( expl_type == _CFA_ ) {
                init_st = start_st;
                CFA_state st = get_init_cfa_state();
                init_st.set_cfa_state(pid, st);
            }
            else if ( expl_type == _CFG_ ) {
                // set pc to init entry
                if( c->has_init_cfg() ) {
                }
                else init_st = start_st;

                //set pc to main entry
                //Util::msg(2,"get_init_diff2: setting pc val to "+int2str(c->get_main_entry_pcval())); 
                init_st.set_pcval(pid, c->get_main_entry_pcval());

            }
            else assert(0);
        }*/

        template<class DP>
        typename DP::expr get_init_constraints(DP& dp, int depth=0)  const {
            if( expl_type == _CFA_ ) {
                return fa.get_init_f(dp, pid, depth); 
                
            }
            else if ( expl_type == _CFG_ ) {
                const list<Assign>& alist = c->get_init_sym_form();
                return eval_sym_alist(dp, alist, pid, depth); //depth = 0
            }
            else assert(0);
        }

        Expr* get_init_glb_expr() const {
            CHK ( expl_type == _CFG_ ) ;
            return c->get_init_glb_sym_form();
        }


        template<class DP>
        typename DP::expr explore_vd_cases(DP& dp, const Var_dcl& vd, const Case_map& cm, int depth) {
            typedef typename DP::expr expr;
            expr var0 = eval_name_expr(dp,vd,pid,depth);

            expr rhs = var0; //last case in ite

                //TODO: check with the reverse order encoding: from end to begin
            const_foreach(it, cm) {
                const Guard_expr_list& gel = it->first;
                const Expr* v = it->second;
                expr rhs_expr = eval_sym_expr(dp,v,pid,depth);

                expr curr = dp.mk_true();

                const_foreach(itl, gel) {
                    const Guard_expr& gexpr = *itl;
                    expr a = eval_guard_expr(dp,gexpr,pid,depth);
                    curr = dp.mk_and(curr, a);
                }

                rhs = dp.mk_ite(curr,rhs_expr,rhs); //TODO: encode as and, or
            }

            expr var1 = eval_name_expr(dp,vd,pid,depth+1);
            expr assign_expr = dp.mk_eq(var1,rhs);
            //DP::print(assign_expr);
            return assign_expr;
        }

        template<class DP>
        typename DP::expr explore_cfg ( DP& dp, int depth ) {
            const map<Var_dcl, Case_map>& var2cases = c->get_sym_form();
            typename DP::expr res = dp.mk_true();
            const_foreach(it, var2cases) {
                const Var_dcl& vd = it->first;
                const Case_map& cm = it->second;
                typename DP::expr tmp = explore_vd_cases(dp,vd, cm, depth);
                res = dp.mk_and(res, tmp);
            }
            //add logic constraints
            
            typename DP::expr tmp = c->get_logic().eval_sym(dp,pid,depth);
            res = dp.mk_and(res, tmp);
            
            return res;
        }

        template<class DP>
        typename DP::expr explore_cfa ( DP& dp, int depth ) {
            return fa.get_trans_f(dp, pid, depth);
        }

        template<class DP>
        typename DP::expr explore ( DP& dp, int depth ) {

            if( expl_type == _CFG_ ) {
                return explore_cfg(dp,depth);
            }
            else if( expl_type == _CFA_) {
                return explore_cfa(dp,depth);
            }
            else assert(0);
        }

        template<class DP>
        void declare_state_var ( DP& dp, int depth ) {
            CHK( expl_type == _CFA_ );
            Ty ty = fa.get_st_var_type();
            Naming::declare_state_var(dp, pid, depth, ty); 
        }
//for final/err state detection
        bool is_final(const CFA_state& st) const {
            CHK( expl_type == _CFA_ );
            return fa.is_final(st);
        }

        bool has_final() const {
            CHK( expl_type == _CFA_ );
            return !fa.only_sink_is_final();
        }

        template<class DP>
        typename DP::expr get_final_f( DP& dp, int depth) const {
            CHK( expl_type == _CFA_ );
            return fa.is_final_f( dp, pid, depth);
        }

};


//-- sSystem explorer

class Sys_expl_sym
{
    protected:
        const sSystem & sys;
        const Mem_map& mem;
        vector < Proc_explorer_sym > procs;
        map<Sys_state, Sys_state> reach_st2pre_st; //stores reachable states; map to their preecessors
        size_t fa_start_index;
        //DP::context ct;
        DP dp_base;
        

        bool CHECK_REACH_ERR, CHECK_PRP; //run time flags

        void build_proc_explorers() {
            const CFG_comps& cfg_comps = sys.get_cfg_components();
            size_t index=0;
            const_foreach(it, cfg_comps) {
                Proc_explorer_sym pexp(*it);
                procs.push_back(pexp);
                index++;
            }

            fa_start_index = index;

            const sSystem::CFA_comps& fa_comps = sys.get_fa_components();
            const_foreach(it2, fa_comps) {
                Proc_explorer_sym pexp(*it2);
                procs.push_back(pexp);
            }
        }


    public:

        Sys_expl_sym (const sSystem & _sys): sys (_sys), mem(_sys.get_mem_map()) {
            build_proc_explorers();
            CHECK_REACH_ERR = false; //TODO: handle case when it is true
            CHECK_PRP = false;
         //   ct = DP::mk_context();
        } 
        //~Sys_expl_sym() { DP::del_context(ct); }

/* for the init global state shared among all */
        Expr* get_init_glb_state() {
            Expr *res = ExprManager::get_true();
            for(uint index=0 ; index < fa_start_index; ++index) {
                Expr *e = procs[index].get_init_glb_expr();
                res = ExprManager::get_and(res,e);
            }
            return res;
        }


        template<class DP>
        typename DP::expr get_init_states ( DP& dp, int depth=0 ) {
            //depth = 0, add init sys state, this may add extra constraints
            typename DP::expr res = eval_sym_expr(dp, sys.get_init_state(), -1, depth); 

            for(uint index=0 ; index < procs.size(); ++ index) {
                res = dp.mk_and( res, procs[index].get_init_constraints(dp,depth) );
            }

            //add event constraints

            return res;
        }

        template<class DP>
        typename DP::expr get_init_states_P (DP& dp, const sPropDFA& P, int depth=0) {
            typename DP::expr res = get_init_states(dp,depth);
            // add P constraints
            res = dp.mk_and( res, fa_get_init_f(P,dp,-1,depth));
            return res;
        }


        const Mem_map& get_memory() { return mem;}

        template<class DP>
        void declare_vars( DP& dp, int depth, bool add_bv = true ) {
            mem.DP_declare_vars(dp,sSystem::globals,depth);
            if ( add_bv ) {
                typename DP::expr e = mem.get_bv_constraints(dp,sSystem::globals,depth);
                dp.assertdp(e);
            }
            for(size_t i = fa_start_index; i < procs.size(); i++)
                procs[i].declare_state_var(dp,depth);
        }
        
        template<class DP>
        void declare_vars_P(DP& dp, int depth, const sPropDFA& P, bool add_bv = true) {
            declare_vars(dp,depth,add_bv);
            Ty ty = fa_get_st_var_type(P);
            Naming::declare_state_var(dp,-1,depth,ty);
        }

        DP::expr check_diff_cfa_states(DP& dp, int d0, int d1) {
            DP::expr ret = dp.mk_false();
            for(uint i=fa_start_index; i<procs.size(); ++i) {
                Pid pid = procs[i].get_pid();
                DP::expr e0 = get_fa_state_var(dp,pid,d0);
                DP::expr e1 = get_fa_state_var(dp,pid,d1);
                ret = dp.mk_or(ret, dp.mk_diseq(e0,e1) );
            }
            return ret;
        }

        DP::expr check_diff_prop_states(DP& dp, int d0, int d1) {
        //check if prop states at d0 are different from states at d1
        //compute expression that is sat iff s(d0) is diff from s(d1)
            DP::expr e0 = get_fa_state_var(dp,-1,d0);
            DP::expr e1 = get_fa_state_var(dp,-1,d1);
            return dp.mk_diseq(e0,e1);
        }

        DP::expr check_diff_states(DP& dp, int d0, int d1) {
        //check if states at d0 are different from states at d1
        //compute expression that is sat iff s(d0) is diff from s(d1)
            return mem.get_diff_constraints(dp, sSystem::globals, d0,d1);
        }
        
        DP::expr get_uniq (DP& dp, int depth) {
            DP::expr uniq = dp.mk_true();
            for(int i=0; i< depth; i++) {
                DP::expr a[3];
                a[0] = check_diff_states(dp,i,depth);
                a[1] = check_diff_prop_states(dp,i,depth);
                a[2] = check_diff_cfa_states(dp,i,depth) ;
                DP::expr diff = dp.mk_or(a,3);
                uniq = dp.mk_and(uniq, diff );
            }
            return uniq;
        }

        bool check_err_reach () ;
        bool check_fix_point(DP& dp, const sPropDFA& P, int depth) ;
        bool check_fix_point_plain(DP& dp, int depth) ;

        void explore() {
            //do BMC 
            DP dp;
            declare_vars(dp, 0);
            //get init state constraints
            int max_depth = sys.get_depth();
            DP::expr res = get_init_states(dp);
            //DP_expr res = DP::mk_true(ct);
            for(int depth=1;  ; ++depth) {
                Util::message(2,"Exploring depth = %d\n",depth);
                declare_vars(dp,depth);
                for(uint i=0; i<procs.size(); ++i) {
               // for(uint i=procs.size()-1; i>0; i--) {
                    //cfg_explore or cfa_explore: add constraints 
                    Util::message(3,"Exploring proc pid %d\n",i);
                    res = dp.mk_and( res, procs[i].explore(dp,depth-1) );
                }
                dp.assertdp(res);
                CHK ( !dp.inconsistent() ) ;
                Util::msg(3,"explore::show_sat"); dp.show_sat();
                if( check_fix_point_plain(dp,depth) ) {
                    Util::msg(2,"Fixpoint reached..explore over.");
                    break;
                }
                //DP::push(ct);
                if ( max_depth != -1 && depth == max_depth) {
                    Util::message(2,"Explore over..max depth %d reached.\n",depth);
                    break;
                }
            }
        }

        template<class DP>
        typename DP::expr get_err_f(DP& dp, int depth, const sPropDFA& P) {
            typename DP::expr res = dp.mk_true();
            for(size_t i=fa_start_index; i< procs.size(); ++i) {
                res = dp.mk_and(res, procs[i].get_final_f(dp,depth));
            }
            res = dp.mk_and(res, fa_is_final_f(P,dp,-1,depth));
            return res;
        }

        template<class DP>
        typename DP::expr get_prop_trans_f(DP& dp, const sPropDFA& P, int depth) {
            return fa_get_trans_f(P, dp, -1, depth);
        }


        void gen_ce( DP& dp, bool gen, DP::expr err, sSys_CE& ce, assertion_id) ;

        void lift_act_vars_unsat ( DP& dp, const sCFA_act& ceA, int adepth, sCFA_act& split_act) ;
        bool generalize_split (const sPropDFA& P, const sCFA_trace& u, const sCFA_trace& v, const sCFA_act &A, sCFA_act& split_sig ) ;
        
        bool check_err(DP& dp, const sPropDFA& P, int depth, bool must_gen_ce, bool gen, sSys_CE& ce) ;
        bool check_step(DP& dp, const sPropDFA& P, int depth) ;
        bool check_base (DP& dp, const sPropDFA& P, sSys_CE& ce, int depth, int err_depth, bool must_gen_ce, bool gen ) ;
        bool check_prop(const sPropDFA& P, sSys_CE& ce, bool must_gen_ce = true, bool gen = false, bool fixpt = true) ;

        bool check_interpolant_fp(FociDP& dp, const sPropDFA& P, int depth, int start_depth) ;
        bool check_bdd_prop(const sPropDFA& P, sSys_CE& ce) ;
};


#endif
