#include"tys.h"

struct Ty_is_chan_vis {
    void operator() (const bTy& bty) {
        switch(bty) {
            case ChanTy: ret = true; break;
            default: ret = false; break;
        }
    }

    template<typename T> void operator() (const T& vd) { ret = false; }
    bool ret;
};

struct Ty_is_ev_vis {
    void operator() (const bTy& bty) {
        switch(bty) {
            case EvTy: ret = true; break;
            default: ret = false; break;
        }
    }

    template<typename T> void operator() (const T& ty) { ret = false; }
    bool ret;
};

struct Ty_values_vis {
    list<Const>& clist;
    int size;

    enum mode {SIZE, VALS};
    mode m;

    Ty_values_vis(const Ty& ty, list<Const>& _clist, mode _m = VALS) : clist(_clist),m(_m) {
        size=-1;
        VAR::apply_visitor(*this,ty);
    }

    void operator() (const bTy& bty) {
        switch( bty ) {
            case BitTy:
            case BoolTy:
            case EvTy:
                if( m == VALS ) {
                clist.push_back(Const(false));
                clist.push_back(Const(true));
                }
                size=1;
                break;
            
            default: assert(0);
        }
    }

    void operator() (const BvTy& bvty) {
        size = (int)pow(2,bvty);
        if ( m == VALS)
            for(int i=0; i< size ; i++) clist.push_back(i);
    }

    template<typename T> void operator() (const T& ty) { assert(0); }

};


bool is_ty_chan(const Ty& ty) {
    Ty_is_chan_vis vis;
    apply_visitor(vis,ty);
    return vis.ret;
}

bool is_ty_ev(const Ty& ty) {
    Ty_is_ev_vis vis;
    apply_visitor(vis,ty);
    return vis.ret;
}

struct Ty_is_bv_vis {
    void operator() (const BvTy& bvty) {
        ret = true;
    }

    template<typename T> void operator() (const T& ty) { ret = false; }
    bool ret;
};

bool is_ty_bv(const Ty& ty) {
    Ty_is_bv_vis vis;
    apply_visitor(vis,ty);
    return vis.ret;
}

void get_ty_values(const Ty& ty, list<Const>& clist) {
    Ty_values_vis vis(ty, clist);
}

int get_ty_size(const Ty& ty) {
    list<Const> clist;
    Ty_values_vis vis(ty, clist, Ty_values_vis::SIZE);
    return vis.size;
}

struct Ty_yices_str_vis {
    string str;

    Ty_yices_str_vis(const Ty& ty)  {
        VAR::apply_visitor(*this,ty);
    }

    void operator() (const bTy& bty) {
        switch( bty ) {
            case BitTy:
            case BoolTy:
            case EvTy:
                str = "bool";
                break;
            case IntTy:
                str = "int";
                break;
            
            case ByteTy:
            default: assert(0);
        }
    }

    void operator() (const BvTy& bvty) {
        //str = "(bitvector "+int2str(bvty)+")";
        str = "int";
    }

    template<typename T> void operator() (const T& ty) { assert(0); }

};

string ty2yices_str(const Ty& ty) {
    Ty_yices_str_vis vis(ty);
    return vis.str;
}


struct Ty_str_vis {
    string str;

    Ty_str_vis(const Ty& ty)  {
        VAR::apply_visitor(*this,ty);
    }

    void operator() (const bTy& bty) {
        switch( bty ) {
            case BitTy:
            case BoolTy:
            case EvTy:
                str = "bool";
                break;
            case IntTy:
                str = "int";
                break;
            
            case ByteTy:
            default: assert(0);
        }
    }

    void operator() (const BvTy& bvty) {
        str = "bv("+int2str(bvty)+")";
    }

    template<typename T> void operator() (const T& ty) { assert(0); }

};

string ty2str(const Ty& ty) {
    Ty_str_vis vis(ty);
    return vis.str;
}

bool operator < (const Ty& ty1, const Ty& ty2 ) {
    return ty2str(ty1) < ty2str(ty2);
}
