#include"val.h"
#include"util.h"
#include"ops.h"

const Val_x_int Val_x_int::ValX = Val_x_int();

Val_x_int Val_x_int::operator - ()  const {
    CHK (is_int()); return -i;
    
}
Val_x_int Val_x_int::operator ! ()  const {
    CHK (is_int()); return !i;
    
}


Val_x_int Val_x_int::operator + (const Val_x_int& v) const {
    CHK (is_int() ); return i+v.i;
    
}
Val_x_int Val_x_int::operator - (const Val_x_int& v) const {
    CHK (is_int() ); return i-v.i;
    
}

Val_x_int Val_x_int::operator * (const Val_x_int& v) const {
    CHK (is_int()); return i*v.i;
    
}

Val_x_int Val_x_int::operator / (const Val_x_int& v) const { 
    CHK (is_int()); return i/v.i; 
    
}

Val_x_int Val_x_int::operator ^ (const Val_x_int& v) const {
    CHK (is_int() );
    return i^v.i;
    
}
Val_x_int Val_x_int::operator % (const Val_x_int& v) const {
    CHK (is_int() );
    return i%v.i;
    
}

Val_x_int Val_x_int::operator | (const Val_x_int& v) const {
    CHK (is_int() );
    return i|v.i;
    
}
Val_x_int Val_x_int::operator & (const Val_x_int& v) const {
    CHK (is_int() );
    return i&v.i;
    
}

bool Val_x_int::operator == (const Val_x_int& v) const {
    CHK (is_int() );
    return i == v.i;
    
}
bool Val_x_int::operator != (const Val_x_int& v) const {
    CHK (is_int() );
    return i != v.i;
    
}
bool Val_x_int::operator < (const Val_x_int& v) const {
    CHK (is_int() );
    return i < v.i;
}
bool Val_x_int::operator > (const Val_x_int& v) const {
    CHK (is_int() );
    return i > v.i;
}
bool Val_x_int::operator <= (const Val_x_int& v) const {
    CHK (is_int() );
    return i <= v.i;
}
bool Val_x_int::operator >= (const Val_x_int& v) const {
    CHK (is_int() );
    return i >= v.i;
}

bool Val_x_int::operator && (const Val_x_int& v) const {
    CHK (is_int() );
    return i && v.i;
}
bool Val_x_int::operator || (const Val_x_int& v) const {
    CHK (is_int() );
    return i || v.i;
}
Val_x_int Val_x_int::operator >> (const Val_x_int& v) const {
    CHK (is_int() );
    return i >> v.i;
}
Val_x_int Val_x_int::operator << (const Val_x_int& v) const {
    CHK (is_int() );
    return i << v.i;
}

string Val_x_int::to_str() const { 
    if (is_int() ) return int2str(i);
    else return "X";
}

bool Val_x_int::is_int() const { return get_type() == INT; }
int Val_x_int::to_int() const { CHK(is_int()); return i;}


bool Val_x_int::is_t() const {
    CHK (is_int() );
    return !(is_f()); 
}
bool Val_x_int::is_f() const { CHK(is_int()); return i == 0; }
